package cz.tendersystems.helpdesk.data.organizationalstructure;

import java.io.*;
import java.util.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;

public class OutsourcerData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -265252280762754667L;

	private Long id;

	@NotNull
	@Size(min = 1, max = 50)
	private String companyName;

	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdDateTime = new Date();

	@NotNull
	private Boolean active = true;

	public OutsourcerData() {
	}

	public OutsourcerData(Outsourcer entity) {
		this.id = entity.getId();
		this.companyName = entity.getCompanyName();
		this.createdDateTime = entity.getCreatedDateTime();
		this.active = entity.getActive();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCompanyName() {
		return companyName;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}
}
