package cz.tendersystems.helpdesk.data.organizationalstructure;

import java.io.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;

public class UserOutsourcerData extends SystemUserData implements Serializable {

	private static final long serialVersionUID = 1L;

	@NotNull
	private OutsourcerData outsourcer;

	public UserOutsourcerData() {
		super();
		setRoleType(RoleType.OUTSOURCER);
	}

	public UserOutsourcerData(UserOutsourcer entity) {
		super(entity);
		this.outsourcer = new OutsourcerData(entity.getOutsourcer());
	}

	public OutsourcerData getOutsourcer() {
		return outsourcer;
	}

	public void setOutsourcer(OutsourcerData outsourcer) {
		this.outsourcer = outsourcer;
	}
}
