package cz.tendersystems.helpdesk.data.organizationalstructure;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class UserSolverData extends SystemUserData implements Serializable {

	static final long serialVersionUID = 73021727395040243L;

	private List<ProductData> products = new ArrayList<>();

	public UserSolverData() {
	}

	public UserSolverData(UserSolver entity) {
		super(entity);

		this.products = convertOnCollection(entity.getProducts());
	}

	private List<ProductData> convertOnCollection(List<Product> entity) {
		List<ProductData> data = new ArrayList<>();
		entity.forEach(e -> data.add(new ProductData(e)));

		return data;
	}

	public List<ProductData> getProducts() {
		return products;
	}

	public void setProducts(List<ProductData> products) {
		this.products = products;
	}
}
