package cz.tendersystems.helpdesk.data.organizationalstructure.embeddable;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

@Embeddable
public class ChangePasswordData implements Serializable {

	private static final long serialVersionUID = 7277847138565151139L;

	@Size(max = 50)
	private String key;

	private Date expirationDate;

	public ChangePasswordData() {
	}

	public ChangePasswordData(ChangePassword object) {
		key = object.getKey();
		expirationDate = object.getExpirationDate();
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public Date getExpirationDate() {
		return expirationDate;
	}

	public void setExpirationDate(Date expirationDate) {
		this.expirationDate = expirationDate;
	}

	@Override
	public String toString() {
		return MessageFormat.format("Key: {0}, expirationDate: {1}", getKey(), getExpirationDate());
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof ChangePasswordData) {
			ChangePasswordData changePassword = (ChangePasswordData) obj;

			boolean equalityOfKey = getKey() != null && getKey().equals(changePassword.getKey());
			boolean equalityOfExpirationDate = getExpirationDate() != null && getExpirationDate().equals(changePassword.getExpirationDate());

			return equalityOfKey && equalityOfExpirationDate;
		} else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		int hash = getKey() == null ? 47 : getKey().hashCode();

		hash += 47 * (getExpirationDate() == null ? 1 : getExpirationDate().hashCode());

		return hash;
	}
}
