package cz.tendersystems.helpdesk.data.organizationalstructure.sla;

import java.io.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class AssignmentData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -7533712631689619311L;

	private Long id;

	@NotNull
	private SlaSchemaData slaSchema = new SlaSchemaData();

	private OutsourcerData outsourcer;

	@NotNull
	private ProductData product = new ProductData();

	public AssignmentData() {
	}

	public AssignmentData(Assignment entity) {
		this.id = entity.getId();
		this.slaSchema = new SlaSchemaData(entity.getSlaSchema());
		this.outsourcer = entity.getOutsourcer() == null ? null : new OutsourcerData(entity.getOutsourcer());
		this.product = new ProductData(entity.getProduct());
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public SlaSchemaData getSlaSchema() {
		return slaSchema;
	}

	public void setSlaSchema(SlaSchemaData slaSchema) {
		this.slaSchema = slaSchema;
	}

	public OutsourcerData getOutsourcer() {
		return outsourcer;
	}

	public void setOutsourcer(OutsourcerData outsourcer) {
		this.outsourcer = outsourcer;
	}

	public ProductData getProduct() {
		return product;
	}

	public void setProduct(ProductData product) {
		this.product = product;
	}
}
