package cz.tendersystems.helpdesk.data.organizationalstructure.sla;

import java.io.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class ProductData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -2842972845875259188L;

	private Long id;

	@NotNull
	@Size(min = 1, max = 50)
	private String name;

	@NotNull
	private Boolean active = false;

	public ProductData() {
	}

	public ProductData(Product entity) {
		this.id = entity.getId();
		this.name = entity.getName();
		this.active = entity.getActive();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}
}
