package cz.tendersystems.helpdesk.data.organizationalstructure.sla;

import java.io.*;
import java.util.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class SlaSchemaData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -3940561436834688360L;

	private Long id;

	@NotNull
	@Size(min = 1, max = 255)
	private String name;

	@NotNull
	private Date reactionTime;

	@NotNull
	private Date timeToSolve;

	@NotNull
	private Boolean active = true;

	public SlaSchemaData(Long id, String name) {
		this.id = id;
		this.name = name;
	}

	public SlaSchemaData() {
	}

	public SlaSchemaData(SlaSchema entita) {
		this.id = entita.getId();
		this.name = entita.getName();
		this.reactionTime = entita.getReactionTime();
		this.timeToSolve = entita.getTimeToSolve();
		this.active = entita.getActive();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Date getReactionTime() {
		return reactionTime;
	}

	public void setReactionTime(Date reactionTime) {
		this.reactionTime = reactionTime;
	}

	public Date getTimeToSolve() {
		return timeToSolve;
	}

	public void setTimeToSolve(Date timeToSolve) {
		this.timeToSolve = timeToSolve;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}
}
