package cz.tendersystems.helpdesk.data.organizationalstructure.sla;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class TimeActivityData implements Serializable {

	private static final long serialVersionUID = -2283924652659056973L;

	private Long id;

	@NotNull
	private DayName dayName;

	@NotNull
	@Temporal(TemporalType.TIME)
	private Date startTime;

	@NotNull
	@Temporal(TemporalType.TIME)
	private Date endTime;

	public TimeActivityData() {
	}

	public TimeActivityData(TimeActivity entity) {
		this.id = entity.getId();
		this.dayName = entity.getDayName();
		this.startTime = entity.getStartTime();
		this.endTime = entity.getEndTime();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public DayName getDayName() {
		return dayName;
	}

	public void setDayName(DayName dayName) {
		this.dayName = dayName;
	}

	public Date getStartTime() {
		return startTime;
	}

	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	@Override
	public String toString() {
		return MessageFormat.format("ID: {0}, NameDay: {1}, startTime: {2}, endTime: {3}", getId(), getDayName(), getStartTime(), getEndTime());
	}

	@Override
	public boolean equals(Object obj) {
		return obj instanceof TimeActivityData && ((TimeActivityData) obj).getDayName().equals(getDayName());
	}

	@Override
	public int hashCode() {
		int hash = getId() == null ? 47 : getId().hashCode();

		hash += 47 * (getDayName() == null ? 1 : getDayName().hashCode());
		hash += 47 * (getStartTime() == null ? 1 : getStartTime().hashCode());
		hash += 47 * (getEndTime() == null ? 1 : getEndTime().hashCode());

		return hash;
	}

}
