package cz.tendersystems.helpdesk.data.request;

import java.io.*;
import javax.persistence.*;
import javax.validation.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.request.*;

public class AuthorData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = 6378784780184447551L;

	private Long id;

	@Size(min = 1, max = 50)
	private String companyName;

	@Embedded
	@Valid
	private PersonData anonymous;

	private UserOutsourcerData loggedUser;

	public AuthorData() {
	}

	public AuthorData(Author entity) {
		this.id = entity.getId();
		this.companyName = entity.getCompanyName();
		this.anonymous = entity.getAnonymous() == null ? null : new PersonData(entity.getAnonymous());
		this.loggedUser = entity.getLoggedUser() == null ? null : new UserOutsourcerData(entity.getLoggedUser());
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCompanyName() {
		return companyName;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public PersonData getAnonymous() {
		return anonymous;
	}

	public void setAnonymous(PersonData anonymous) {
		this.anonymous = anonymous;
	}

	public UserOutsourcerData getLoggedUser() {
		return loggedUser;
	}

	public void setLoggedUser(UserOutsourcerData loggedUser) {
		this.loggedUser = loggedUser;
	}
}
