package cz.tendersystems.helpdesk.data.request;

import java.io.*;
import java.util.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.request.*;

public class CommentData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = 2504334212659577105L;

	private Long id;

	@NotNull
	private String text;

	@NotNull
	private Date createdDateTime;

	@NotNull
	private RequestStatus requestStatus = RequestStatus.NEW;

	@NotNull
	@Size(min = 1, max = 255)
	private String author;

	public CommentData() {
	}

	public CommentData(Comment entity) {
		this.id = entity.getId();
		this.text = entity.getText();
		this.createdDateTime = entity.getCreatedDateTime();
		this.requestStatus = entity.getRequestStatus();
		this.author = entity.getAuthor();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public RequestStatus getRequestStatus() {
		return requestStatus;
	}

	public void setRequestStatus(RequestStatus requestStatus) {
		this.requestStatus = requestStatus;
	}

	public String getAuthor() {
		return author;
	}

	public void setAuthor(String author) {
		this.author = author;
	}
}
