package cz.tendersystems.helpdesk.data.request;

import java.io.*;
import java.util.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.request.File;

public class FileData extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -6220834333923889324L;

	private Long id;

	@NotNull
	@Size(min = 1, max = 255)
	private String name;

	@NotNull
	@Size(min = 1, max = 150)
	private String contentType;

	@NotNull
	@Min(1)
	private Long Size;

	@NotNull
	private Date createdDateTime;

	private InputStream inputStream;

	public FileData() {
	}

	public FileData(File entity) {
		this.id = entity.getId();
		this.name = entity.getName();
		this.contentType = entity.getContentType();
		this.Size = entity.getSize();
		this.createdDateTime = entity.getCreatedDateTime();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	public Long getSize() {
		return Size;
	}

	public void setSize(Long size) {
		Size = size;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public InputStream getInputStream() {
		return inputStream;
	}

	public void setInputStream(InputStream inputStream) {
		this.inputStream = inputStream;
	}
}
