package cz.tendersystems.helpdesk.entity.general;

import java.io.*;
import java.text.*;

@SuppressWarnings("serial")
public abstract class AbstractEntity<E extends Serializable> implements Serializable {

	public abstract E getId();

	public boolean equals(Object obj) {
		if (obj instanceof AbstractEntity<?>) {
			boolean equilityOfRootClass = getRootClass(this).equals(getRootClass(obj));
			boolean equilityOfId = getId() == null ? this == obj : getId().equals(((AbstractEntity<?>) obj).getId());

			return equilityOfRootClass && equilityOfId;
		}

		return false;
	}

	public int hashCode() {
		return getId() == null ? -1 : getId().hashCode();
	}

	public String toString() {
		return MessageFormat.format("{0} (id = {1})", getClass().getSimpleName(), getId());
	}

	private Class<?> getRootClass(Object objekt) {
		Class<?> trida = objekt.getClass();

		while (!trida.getSuperclass().equals(AbstractEntity.class) && !trida.getSuperclass().equals(Object.class)) {
			trida = trida.getSuperclass();
		}

		return trida;
	}
}
