package cz.tendersystems.helpdesk.entity.organizationalstructure;

import java.util.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.general.*;

@Entity
public class Outsourcer extends AbstractEntity<Long> {

	private static final long serialVersionUID = -1405087825603950420L;

	@Id
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "outsourcer")
	@TableGenerator(name = "outsourcer", allocationSize = 1, initialValue = 0)
	private Long id;

	@NotNull
	@Size(min = 1, max = 50)
	private String companyName;

	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdDateTime = new Date();

	@NotNull
	private Boolean active = true;

	public Outsourcer() {
	}

	public Outsourcer(OutsourcerData data) {
		convert(this, data);
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCompanyName() {
		return companyName;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}

	public static void convert(Outsourcer entity, OutsourcerData data) {
		entity.setCompanyName(data.getCompanyName());
		entity.setCreatedDateTime(data.getCreatedDateTime());
		entity.setActive(data.getActive());
	}
}
