package cz.tendersystems.helpdesk.entity.organizationalstructure;

import java.io.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;

@Entity
public class UserOutsourcer extends SystemUser implements Serializable {

	private static final long serialVersionUID = -3296233305399706643L;

	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	private Outsourcer outsourcer;

	public UserOutsourcer() {
		super();
	}

	public UserOutsourcer(UserOutsourcerData data) {
		UserOutsourcer.convert(this, data);
	}

	public Outsourcer getOutsourcer() {
		return outsourcer;
	}

	public void setOutsourcer(Outsourcer outsourcer) {
		this.outsourcer = outsourcer;
	}

	public static void convert(UserOutsourcer entity, UserOutsourcerData data) {
		SystemUser.convert(entity, data);
		entity.setOutsourcer(new Outsourcer(data.getOutsourcer()));
	}
}
