package cz.tendersystems.helpdesk.entity.organizationalstructure.sla;

import java.io.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;

@Entity
public class Assignment extends AbstractEntity<Long> implements Serializable {

	private static final long serialVersionUID = -1125510292600897024L;

	@Id
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "assignment")
	@TableGenerator(name = "assignment", allocationSize = 1, initialValue = 0)
	private Long id;

	@NotNull
	@ManyToOne(fetch = FetchType.LAZY, cascade = CascadeType.PERSIST)
	private SlaSchema slaSchema;

	@ManyToOne(fetch = FetchType.LAZY)
	private Outsourcer outsourcer;

	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	private Product product;

	public Assignment() {
	}

	public Assignment(AssignmentData data) {
		convert(this, data);
	}

	@Override
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public SlaSchema getSlaSchema() {
		return slaSchema;
	}

	public void setSlaSchema(SlaSchema slaSchema) {
		this.slaSchema = slaSchema;
	}

	public Outsourcer getOutsourcer() {
		return outsourcer;
	}

	public void setOutsourcer(Outsourcer outsourcer) {
		this.outsourcer = outsourcer;
	}

	public Product getProduct() {
		return product;
	}

	public void setProduct(Product product) {
		this.product = product;
	}

	private static void convert(Assignment entity, AssignmentData data) {
		entity.setSlaSchema(new SlaSchema(data.getSlaSchema()));
		entity.setOutsourcer(data.getOutsourcer() == null ? null : new Outsourcer(data.getOutsourcer()));
		entity.setProduct(new Product(data.getProduct()));
	}
}
