package cz.tendersystems.helpdesk.entity.organizationalstructure.sla;

import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.general.*;

@Entity
public class Product extends AbstractEntity<Long> {

	private static final long serialVersionUID = -6951160649557650478L;

	@Id
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "product")
	@TableGenerator(name = "product", allocationSize = 1, initialValue = 0)
	private Long id;

	@NotNull
	@Size(min = 1, max = 50)
	private String name;

	@NotNull
	private Boolean active = false;

	public Product() {
	}

	public Product(ProductData data) {
		convert(this, data);
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}

	public static void convert(Product entity, ProductData data) {
		entity.setName(data.getName());
		entity.setActive(data.getActive());
	}
}
