package cz.tendersystems.helpdesk.entity.organizationalstructure.sla;

import java.util.*;
import javax.persistence.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.general.*;

@Entity
public class TimeActivity extends AbstractEntity<Long> {

	private static final long serialVersionUID = 905190562588198151L;

	@Id
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "time_activity")
	@TableGenerator(name = "time_activity", allocationSize = 1, initialValue = 0)
	private Long id;

	@NotNull
	@Enumerated(EnumType.STRING)
	private DayName dayName;

	@NotNull
	@Temporal(TemporalType.TIME)
	private Date startTime;

	@NotNull
	@Temporal(TemporalType.TIME)
	private Date endTime;

	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	private SlaSchema slaSchema;

	public TimeActivity() {
	}

	public TimeActivity(TimeActivityData data) {
		convert(this, data);
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public DayName getDayName() {
		return dayName;
	}

	public void setDayName(DayName dayName) {
		this.dayName = dayName;
	}

	public Date getStartTime() {
		return startTime;
	}

	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public SlaSchema getSlaSchema() {
		return slaSchema;
	}

	public void setSlaSchema(SlaSchema slaSchema) {
		this.slaSchema = slaSchema;
	}

	public static void convert(TimeActivity entita, TimeActivityData data) {
		entita.setDayName(data.getDayName());
		entita.setStartTime(data.getStartTime());
		entita.setEndTime(data.getEndTime());
	}
}
