package cz.tendersystems.helpdesk.exception;

import java.text.*;
import javax.ejb.*;

@ApplicationException(inherited = true, rollback = true)
public class GeneralException extends RuntimeException {

	private static final long serialVersionUID = -543359725902517898L;

	private Object[] parameters;

	public GeneralException(String message, Object... parameters) {
		super(MessageFormat.format(message, parameters));

		this.parameters = parameters;
	}

	public GeneralException(String message, Throwable cause, Object... parameters) {
		super(MessageFormat.format(message, parameters), cause);

		this.parameters = parameters;
	}

	public Object[] getParameters() {
		return parameters;
	}
}