package cz.tendersystems.helpdesk.exception;

import java.lang.reflect.*;
import java.util.*;

public class HelpdeskException extends GeneralException {

	private static final long serialVersionUID = -543359725902517898L;

	public HelpdeskException(String message, Object... parameters) {
		super(message, parameters);
	}

	public HelpdeskException(String message, Throwable cause, Object... parameters) {
		super(message, cause, parameters);
	}

	public static List<Throwable> getException(Throwable cause) {
		List<Throwable> exceptions = new ArrayList<Throwable>();

		do {
			exceptions.add(cause);

			if (cause.equals(cause.getCause())) {
				break;
			}

			cause = cause instanceof InvocationTargetException ? ((InvocationTargetException) cause).getTargetException() : cause.getCause();
		} while (cause != null);

		return exceptions;
	}
}