package cz.tendersystems.helpdesk.exception;

import java.text.*;
import java.util.*;

public class ValidationException extends Exception {

	private static final long serialVersionUID = 2250664889456087233L;

	private Map<String, Object> invalidAttributes;
	private Object[] parameters;

	public ValidationException(String message, Object... parameters) {
		super(MessageFormat.format(message, parameters));

		this.parameters = parameters;
	}

	public ValidationException(String message, Throwable cause, Object... parameters) {
		super(MessageFormat.format(message, cause, parameters));

		this.parameters = parameters;
	}

	public ValidationException(String message, Map<String, Object> invalidAttributes) {
		super(message);

		this.invalidAttributes = invalidAttributes;
	}

	public Map<String, Object> getInvalidAttributes() {
		return invalidAttributes;
	}

	public Object[] getParameters() {
		return parameters;
	}
}
