package cz.tendersystems.helpdesk.general;

import java.text.*;
import java.util.*;

public enum DateAndTimeFormat {

	FORMAT_OF_DATE("dd.MM.yyyy"),
	FORMAT_OF_TIME("HH:mm:ss"),
	FORMAT_OF_DATE_AND_TIME("dd.MM.yyyy HH:mm:ss");

	private String format;

	private DateAndTimeFormat(String format) {
		this.format = format;
	}

	public String getFormat() {
		return format;
	}

	public SimpleDateFormat getFormatter() {
		return new SimpleDateFormat(getFormat(), Tools.LOCALIZATION_OF_FORMATTER);
	}

	public String provideDateAsText(Date date) {
		return getFormatter().format(date);
	}
}
