package cz.tendersystems.helpdesk.general;

import org.jboss.logging.*;

public class ToolsLog {

	public static void writeInformation(Class<?> type, String text, Object... parameters) {
		write(type, LevelRecord.INFORMATION, text, parameters);
	}

	public static void writeError(Class<?> type, String text, Object... parameters) {
		write(type, LevelRecord.ERROR, text, parameters);
	}

	public static void write(Class<?> type, LevelRecord levelRecord, String text, Object... parameters) {
		Logger logger = Logger.getLogger(type);

		switch (levelRecord) {
			case INFORMATION:
				logger.infov(text, parameters);
				break;
			case ERROR:
				logger.errorv(text, parameters);
				break;
			default:
				break;
		}
	}

	public enum LevelRecord {
		INFORMATION, ERROR;
	}
}
