package cz.tendersystems.helpdesk.general.validation;

import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.exception.*;

public class ValidationRequest {

	public static void validateRequest(RequestData request, CommentData comment, RequestStatus status) throws ValidationException {
		if (request.getSlaSchema() == null) {
			throw new ValidationException("error.slaSchemaMustNotNull");
		}

		if (!request.getSlaSchema().getActive()) {
			throw new ValidationException("error.slaSchemaMustActive");
		}

		if ((request.getAuthor().getAnonymous() != null && request.getAuthor().getCompanyName() == null) || (request.getAuthor().getAnonymous() == null && request.getAuthor().getCompanyName() != null)) {
			throw new ValidationException("error.badAnonymousAuthor");
		}

		if ((request.getAuthor().getAnonymous() != null || request.getAuthor().getCompanyName() != null) && request.getAuthor().getLoggedUser() != null) {
			throw new ValidationException("error.badLoggedUser");
		}

		if (comment == null) {
			throw new ValidationException("error.commentMustNotNull");
		}

		if (RequestStatus.NEW.equals(request.getRequestStatus()) && status.equals(RequestStatus.SOLVED)) {
			throw new ValidationException("error.requesStatusCanNotBeSolved");
		}
	}
}
