package cz.tendersystems.helpdesk.general.validation;

import java.util.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.exception.*;

public class ValidationSlaSchema {

	public static void validationSlaSchema(AssignmentData data, List<TimeActivityData> timesActiviy) throws ValidationException {
		validationProduct(data.getProduct());
		validationTimesActivity(timesActiviy);
	}

	private static void validationProduct(ProductData data) throws ValidationException {
		if (data.getId() == null) {
			throw new ValidationException("errors.slaSchemaMustHaveProduct");
		}
	}

	private static void validationTimesActivity(List<TimeActivityData> timesActivity) throws ValidationException {
		if (timesActivity.isEmpty()) {
			throw new ValidationException("error.slaSchemaMustHaveAtLeastOneTimeActivity");
		}

		if (timesActivity.size() > 8) {
			throw new ValidationException("error.slaSchemaMustHaveMaxEightTimesActivity");
		}

		for (TimeActivityData data : timesActivity) {
			if (data.getStartTime().getTime() > data.getEndTime().getTime()) {
				throw new ValidationException("error.startTimeCanNotBeAfterEndTime");
			}
		}
	}

}
