package cz.tendersystems.helpdesk.service.general.mail;

import java.io.*;

public class EmbedTemplate implements Serializable {

	private static final long serialVersionUID = 2865043848731665984L;

	private String templateName;
	private String supplantStringValue;
	private String[] parameters;

	public EmbedTemplate(String templateName, String supplantStringValue, String... parameters) {
		this.templateName = templateName;
		this.supplantStringValue = supplantStringValue;
		this.parameters = parameters;
	}

	public String getTemplateName() {
		return templateName;
	}

	public String getSupplantStringValue() {
		return supplantStringValue;
	}

	public String[] getParameters() {
		return parameters;
	}

	public static EmbedTemplate generalSalutationTemplate(String... parameters) {
		return new EmbedTemplate("general_salutation", "@generalSalutation", parameters);
	}

	public static EmbedTemplate generalContactTemplate(String... parameters) {
		return new EmbedTemplate("general_contact", "@contact", parameters);
	}
}
