package cz.tendersystems.helpdesk.service.log.list;

import javax.ejb.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.data.general.*;
import cz.tendersystems.helpdesk.entity.general.*;
import cz.tendersystems.helpdesk.exception.SecurityException;
import cz.tendersystems.helpdesk.service.list.*;

@Stateless
@LocalBean
public class ApplicationLogListService extends AbstractListService<ApplicationLog, ApplicationLogData, ApplicationLogFilter> {

	@Override
	protected Class<ApplicationLog> loadEntityType() {
		return ApplicationLog.class;
	}

	@Override
	protected ApplicationLogData convert(ApplicationLog entity) {
		return new ApplicationLogData(entity);
	}

	@Override
	protected Order prepareMinted(CriteriaBuilder builder, CriteriaQuery<?> query, Root<ApplicationLog> root) {
		return builder.desc(root.<Long> get("id"));
	}

	@Override
	public Response<ApplicationLogData> find(RequestList<ApplicationLogFilter> request) {
		if (!basicSecurityService.isUserAdministrator()) {
			throw new SecurityException("Nedostatecne opravneni nacist seznam logu");
		}

		return super.find(request);
	}
}
