package cz.tendersystems.helpdesk.service.organizationalstructure.list;

import java.util.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.service.list.*;

public class OutsourcerFilter implements Filter<Outsourcer> {

	private Long id;
	private String companyName;
	private Date byDate;
	private Date toDate;
	private Boolean active;

	public OutsourcerFilter() {
	}

	@Override
	public List<Predicate> preparePredicate(CriteriaBuilder builder, CriteriaQuery<?> query, Root<Outsourcer> root) {
		List<Predicate> predicates = new ArrayList<Predicate>();

		if (getId() != null) {
			predicates.add(builder.like(builder.lower(builder.function("str", String.class, root.<Long> get("id"))), "%" + getId() + "%"));
		}

		if (getCompanyName() != null) {
			predicates.add(builder.like(root.<String> get("companyName"), "%" + getCompanyName() + "%"));
		}

		if (getByDate() != null) {
			predicates.add(builder.greaterThanOrEqualTo(root.<Date> get("createdDateTime"), getByDate()));
		}

		if (getToDate() != null) {
			predicates.add(builder.lessThanOrEqualTo(root.<Date> get("createdDateTime"), getToDate()));
		}

		if (getActive() != null) {
			predicates.add(builder.equal(root.<Boolean> get("active"), getActive()));
		}

		return predicates;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCompanyName() {
		return companyName;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public Date getByDate() {
		return byDate;
	}

	public void setByDate(Date byDate) {
		this.byDate = byDate;
	}

	public Date getToDate() {
		return toDate;
	}

	public void setToDate(Date toDate) {
		this.toDate = toDate;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}
}