package cz.tendersystems.helpdesk.service.organizationalstructure.list;

import javax.ejb.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.exception.SecurityException;
import cz.tendersystems.helpdesk.service.list.*;

@Stateless
@LocalBean
public class OutsourcerListService extends AbstractListService<Outsourcer, OutsourcerData, OutsourcerFilter> {

	@Override
	protected Class<Outsourcer> loadEntityType() {
		return Outsourcer.class;
	}

	@Override
	protected OutsourcerData convert(Outsourcer entity) {
		return new OutsourcerData(entity);
	}

	@Override
	protected Order prepareMinted(CriteriaBuilder builder, CriteriaQuery<?> query, Root<Outsourcer> root) {
		return builder.desc(root.<Long> get("id"));
	}

	@Override
	public Response<OutsourcerData> find(RequestList<OutsourcerFilter> request) {
		if (!basicSecurityService.isUserAdministrator()) {
			throw new SecurityException("Nedostatecne opravneni nacist seznam zadavatelu");
		}

		return super.find(request);
	}
}
