package cz.tendersystems.helpdesk.service.organizationalstructure.list;

import javax.ejb.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.exception.SecurityException;
import cz.tendersystems.helpdesk.service.list.*;

@Stateless
@LocalBean
public class UserListService extends AbstractListService<SystemUser, SystemUserData, UserFilter> {

	@Override
	protected Class<SystemUser> loadEntityType() {
		return SystemUser.class;
	}

	@Override
	protected SystemUserData convert(SystemUser entity) {

		return entity instanceof UserOutsourcer ? new UserOutsourcerData((UserOutsourcer) entity) : new UserSolverData((UserSolver) entity);
	}

	@Override
	protected Order prepareMinted(CriteriaBuilder builder, CriteriaQuery<?> query, Root<SystemUser> root) {
		return builder.desc(root.<String> get("loginName"));
	}

	@Override
	public Response<SystemUserData> find(RequestList<UserFilter> request) {
		if (!basicSecurityService.isUserAdministrator()) {
			throw new SecurityException("Nedostatecne opravneni nacist seznam uzivatelu");
		}

		return super.find(request);
	}
}
