package cz.tendersystems.helpdesk.service.organizationalstructure.sla.list;

import java.util.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.service.list.*;

public class ProductFilter implements Filter<Product> {

	private Long id;
	private String name;
	private Boolean active;

	public ProductFilter() {
	}

	@Override
	public List<Predicate> preparePredicate(CriteriaBuilder builder, CriteriaQuery<?> query, Root<Product> root) {
		List<Predicate> predicates = new ArrayList<Predicate>();

		if (getId() != null) {
			predicates.add(builder.like(builder.lower(builder.function("str", String.class, root.<Long> get("id"))), "%" + getId() + "%"));
		}

		if (getName() != null) {
			predicates.add(builder.like(root.<String> get("name"), "%" + getName() + "%"));
		}

		if (getActive() != null) {
			predicates.add(builder.equal(root.<Boolean> get("active"), getActive()));
		}

		return predicates;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}
}