package cz.tendersystems.helpdesk.service.organizationalstructure.sla.list;

import javax.ejb.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.exception.SecurityException;
import cz.tendersystems.helpdesk.service.list.*;

@Stateless
@LocalBean
public class ProductListService extends AbstractListService<Product, ProductData, ProductFilter> {

	@Override
	protected Class<Product> loadEntityType() {
		return Product.class;
	}

	@Override
	protected ProductData convert(Product entity) {
		return new ProductData(entity);
	}

	@Override
	protected Order prepareMinted(CriteriaBuilder builder, CriteriaQuery<?> query, Root<Product> root) {
		return builder.desc(root.<Long> get("id"));
	}

	@Override
	public Response<ProductData> find(RequestList<ProductFilter> request) {
		if (!basicSecurityService.isUserAdministrator()) {
			throw new SecurityException("Nedostatecne opravneni nacist seznam produktu");
		}

		return super.find(request);
	}
}
