package cz.tendersystems.helpdesk.service.organizationalstructure.sla.list;

import javax.ejb.*;
import javax.persistence.criteria.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.exception.SecurityException;
import cz.tendersystems.helpdesk.service.list.*;

@Stateless
@LocalBean
public class SlaSchemaListService extends AbstractListService<SlaSchema, SlaSchemaData, SlaSchemaFilter> {

	@Override
	protected Class<SlaSchema> loadEntityType() {
		return SlaSchema.class;
	}

	@Override
	protected SlaSchemaData convert(SlaSchema entity) {
		return new SlaSchemaData(entity);
	}

	@Override
	protected Order prepareMinted(CriteriaBuilder builder, CriteriaQuery<?> query, Root<SlaSchema> root) {
		return builder.desc(root.<Long> get("id"));
	}

	@Override
	public Response<SlaSchemaData> find(RequestList<SlaSchemaFilter> request) {
		if (!basicSecurityService.isUserAdministrator()) {
			throw new SecurityException("Nedostatecne opravneni nacist seznam sla schema");
		}

		return super.find(request);
	}
}
