package cz.tendersystems.helpdesk.service.request;

import java.util.*;
import javax.ejb.*;
import javax.persistence.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.exception.*;
import cz.tendersystems.helpdesk.general.*;

@Stateless
@LocalBean
public class IdService {

	@PersistenceContext
	EntityManager em;

	public String createId(RequestData request) {
		if (request.getName() == null) {
			throw new HelpdeskException("Nazev pozadavku musi byt vyplnen");
		}

		String id = Tools.generateHash(request.getName(), new Date().toString());

		String HQL = "SELECT COUNT(r) FROM Request r WHERE r.id = :id";

		while ((Long) em.createQuery(HQL).setParameter("id", id).getSingleResult() > 0) {
			id = Tools.generateHash(request.getName(), new Date().toString());
		}

		return id;
	}
}
