package cz.tendersystems.helpdesk.service.security;

import javax.annotation.*;
import javax.ejb.*;
import cz.tendersystems.helpdesk.entity.enums.*;

@Stateless
@LocalBean
public class BasicSecurityService {

	@Resource
	SessionContext sessionContext;

	public String getLoginName() {
		return sessionContext.getCallerPrincipal().getName();
	}

	public boolean isUserLogged() {
		return !sessionContext.getCallerPrincipal().getName().equals("anonymous");
	}

	public boolean isUserAdministrator() {
		return sessionContext.isCallerInRole(RoleType.ADMINISTRATOR.name());
	}

	public boolean isRoleType(RoleType roleType) {
		return sessionContext.isCallerInRole(roleType.name());
	}
}