package cz.tendersystems.helpdesk.data.general;

import org.junit.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.general.*;

public class ApplicationLogDataTest {

	@Test
	public void shouldReturnCorrectObject() {
		ApplicationLogData applicationLog1 = new ApplicationLogData("Test na aplikační log", "Test na aplikcační log {0}", 1);

		Assert.assertNull(applicationLog1.getIdRequest());
		Assert.assertEquals(LevelRecord.INFORMATION, applicationLog1.getLevel());
		Assert.assertEquals("Test na aplikační log", applicationLog1.getOperation());
		Assert.assertNull(applicationLog1.getLoginName());
		Assert.assertNull(applicationLog1.getCreatedDateTime());
		Assert.assertEquals("Test na aplikcační log 1", applicationLog1.getDetails());

		ApplicationLogData applicationLog2 = new ApplicationLogData(LevelRecord.ERROR, "Test aplikačního logu", Long.toString(1l), "Test aplikačního logu");

		Assert.assertEquals(Long.toString(1l), applicationLog2.getIdRequest());
		Assert.assertEquals(LevelRecord.ERROR, applicationLog2.getLevel());
		Assert.assertEquals("Test aplikačního logu", applicationLog2.getOperation());
		Assert.assertNull(applicationLog2.getLoginName());
		Assert.assertNull(applicationLog2.getCreatedDateTime());
		Assert.assertEquals("Test aplikačního logu", applicationLog2.getDetails());

		ApplicationLogData applicationLog3 = new ApplicationLogData(prepareApplicationLog());

		Assert.assertEquals(Long.toString(1l), applicationLog3.getIdRequest());
		Assert.assertNull(applicationLog3.getLevel());
		Assert.assertEquals("Test aplikačního logu", applicationLog3.getOperation());
		Assert.assertNull(applicationLog3.getLoginName());
		Assert.assertNotNull(applicationLog3.getCreatedDateTime());
		Assert.assertNull(applicationLog3.getDetails());
	}

	private ApplicationLog prepareApplicationLog() {
		ApplicationLog applicationLog = new ApplicationLog();
		applicationLog.setIdRequest(Long.toString(1l));
		applicationLog.setOperation("Test aplikačního logu");

		return applicationLog;
	}
}
