package cz.tendersystems.helpdesk.data.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;

public class OutsourcerDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		OutsourcerData outsourcer = new OutsourcerData(prepareOutsourcer());

		Assert.assertEquals("tendersystems", outsourcer.getCompanyName());
		Assert.assertTrue(outsourcer.getActive());
		Assert.assertNotNull(outsourcer.getCreatedDateTime());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareOutsourcerData().equals(prepareOutsourcerData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareOutsourcerData().toString().equals(prepareOutsourcerData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareOutsourcerData().hashCode(), prepareOutsourcerData().hashCode());
	}

	private Outsourcer prepareOutsourcer() {
		Outsourcer outsourcer = new Outsourcer();

		outsourcer.setId(1l);
		outsourcer.setCompanyName("tendersystems");
		outsourcer.setActive(true);
		outsourcer.setCreatedDateTime(new Date());

		return outsourcer;
	}

	private OutsourcerData prepareOutsourcerData() {
		return new OutsourcerData(prepareOutsourcer());
	}
}
