package cz.tendersystems.helpdesk.data.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class UserSOutsourcerDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		UserOutsourcerData user = new UserOutsourcerData(prepareUserOutsourcer());

		Assert.assertEquals("zbynek", user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.WATCHER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertNotNull(user.getOutsourcer());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareUserOutsourcerData().equals(prepareUserOutsourcerData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareUserOutsourcerData().toString().equals(prepareUserOutsourcerData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareUserOutsourcerData().hashCode(), prepareUserOutsourcerData().hashCode());
	}

	private UserOutsourcer prepareUserOutsourcer() {
		UserOutsourcer user = new UserOutsourcer();
		user.setLoginName("zbynek");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.WATCHER);
		user.setPerson(new Person());
		user.setOutsourcer(new Outsourcer());

		return user;
	}

	private UserOutsourcerData prepareUserOutsourcerData() {
		return new UserOutsourcerData(prepareUserOutsourcer());
	}

}
