package cz.tendersystems.helpdesk.data.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class UserSolverDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		UserSolverData user = new UserSolverData(prepareUserSolver());

		Assert.assertEquals("zbynek", user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.WATCHER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertFalse(user.getProducts().isEmpty());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareUserSolverData().equals(prepareUserSolverData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareUserSolverData().toString().equals(prepareUserSolverData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareUserSolverData().hashCode(), prepareUserSolverData().hashCode());
	}

	private UserSolver prepareUserSolver() {
		UserSolver user = new UserSolver();
		user.setLoginName("zbynek");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.WATCHER);
		user.setPerson(new Person());
		user.setProducts(Arrays.asList(new Product()));

		return user;
	}

	private UserSolverData prepareUserSolverData() {
		return new UserSolverData(prepareUserSolver());
	}

}
