package cz.tendersystems.helpdesk.data.organizationstructure.embeddable;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class ChangePasswordDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		ChangePasswordData changePassword = new ChangePasswordData(prepareChangePassword());

		Assert.assertEquals("894orf9hdwhewashaod5j8vz4ieafuooi1d7ip5pabq4a2sbim", changePassword.getKey());
		Assert.assertNotNull(changePassword.getExpirationDate());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareChangePasswordData().equals(prepareChangePasswordData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareChangePasswordData().toString().equals(prepareChangePasswordData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareChangePasswordData().hashCode(), prepareChangePasswordData().hashCode());
	}

	private ChangePassword prepareChangePassword() {
		ChangePassword changePassword = new ChangePassword();
		changePassword.setKey("894orf9hdwhewashaod5j8vz4ieafuooi1d7ip5pabq4a2sbim");
		changePassword.setExpirationDate(new Date());

		return changePassword;
	}

	private ChangePasswordData prepareChangePasswordData() {
		return new ChangePasswordData(prepareChangePassword());
	}
}
