package cz.tendersystems.helpdesk.data.organizationstructure.embeddable;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class PersonDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		PersonData person = new PersonData(preparePerson());

		Assert.assertEquals("Zbyněk", person.getName());
		Assert.assertEquals("Richter", person.getSurname());
		Assert.assertEquals("zbytos@gmail.com", person.getMail());
		Assert.assertEquals("+420604931807", person.getTelephone());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(preparePersonData().equals(preparePersonData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(preparePersonData().toString().equals(preparePersonData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(preparePersonData().hashCode(), preparePersonData().hashCode());
	}

	private Person preparePerson() {
		Person person = new Person();

		person.setName("Zbyněk");
		person.setSurname("Richter");
		person.setMail("zbytos@gmail.com");
		person.setTelephone("+420604931807");

		return person;
	}

	private PersonData preparePersonData() {
		return new PersonData(preparePerson());
	}
}
