package cz.tendersystems.helpdesk.data.organizationstructure.sla;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class AssignmentDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		AssignmentData assignment = new AssignmentData(prepareAssignment());

		Assert.assertNotNull(assignment.getId());
		Assert.assertNotNull(assignment.getSlaSchema());
		Assert.assertNotNull(assignment.getOutsourcer());
		Assert.assertNotNull(assignment.getProduct());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareAssignmentData().equals(prepareAssignmentData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareAssignmentData().toString().equals(prepareAssignmentData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareAssignmentData().hashCode(), prepareAssignmentData().hashCode());
	}

	private Assignment prepareAssignment() {
		Assignment assignment = new Assignment();

		assignment.setId(1l);
		assignment.setSlaSchema(new SlaSchema());
		assignment.setOutsourcer(new Outsourcer());
		assignment.setProduct(new Product());

		return assignment;
	}

	private AssignmentData prepareAssignmentData() {
		return new AssignmentData(prepareAssignment());
	}
}
