package cz.tendersystems.helpdesk.data.organizationstructure.sla;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class ProductDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		ProductData product = prepareProductData();

		Assert.assertNotNull(product.getId());
		Assert.assertEquals("tenderarena", product.getName());
		Assert.assertTrue(product.getActive());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareProductData().equals(prepareProductData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareProductData().toString().equals(prepareProductData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareProductData().hashCode(), prepareProductData().hashCode());
	}

	private Product prepareProduct() {
		Product product = new Product();
		product.setId(1l);
		product.setName("tenderarena");
		product.setActive(true);

		return product;
	}

	private ProductData prepareProductData() {
		return new ProductData(prepareProduct());
	}
}
