package cz.tendersystems.helpdesk.data.organizationstructure.sla;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class SlaSchemaDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		SlaSchemaData slaSchema = new SlaSchemaData(prepareSlaSchema());

		Assert.assertNotNull(slaSchema.getId());
		Assert.assertEquals("Technický problém", slaSchema.getName());
		Assert.assertNotNull(slaSchema.getReactionTime());
		Assert.assertNotNull(slaSchema.getTimeToSolve());
		Assert.assertTrue(slaSchema.getActive());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareSlaSchemaData().equals(prepareSlaSchemaData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareSlaSchemaData().toString().equals(prepareSlaSchemaData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareSlaSchemaData().hashCode(), prepareSlaSchemaData().hashCode());
	}

	private SlaSchema prepareSlaSchema() {
		SlaSchema slaSchema = new SlaSchema();

		slaSchema.setId(1l);
		slaSchema.setName("Technický problém");
		slaSchema.setReactionTime(new Date());
		slaSchema.setTimeToSolve(new Date());
		slaSchema.setActive(true);

		return slaSchema;
	}

	private SlaSchemaData prepareSlaSchemaData() {
		return new SlaSchemaData(prepareSlaSchema());
	}

}
