package cz.tendersystems.helpdesk.data.organizationstructure.sla;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class TimeActivityDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		TimeActivityData timeActivity = new TimeActivityData(prepareTimeActivity());

		Assert.assertNotNull(timeActivity.getId());
		Assert.assertEquals(DayName.FRIDAY, timeActivity.getDayName());
		Assert.assertNotNull(timeActivity.getStartTime());
		Assert.assertNotNull(timeActivity.getEndTime());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareTimeActivityData().equals(prepareTimeActivityData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareTimeActivityData().toString().equals(prepareTimeActivityData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		TimeActivityData timeActivity = prepareTimeActivityData();

		Assert.assertEquals(timeActivity.hashCode(), prepareTimeActivityData().hashCode());
	}

	private TimeActivity prepareTimeActivity() {
		TimeActivity timeActivity = new TimeActivity();

		timeActivity.setId(1l);
		timeActivity.setDayName(DayName.FRIDAY);
		timeActivity.setStartTime(new Date());
		timeActivity.setEndTime(new Date());

		return timeActivity;
	}

	private TimeActivityData prepareTimeActivityData() {
		return new TimeActivityData(prepareTimeActivity());
	}

}
