package cz.tendersystems.helpdesk.data.request;

import org.junit.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.request.*;

public class AuthorDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		AuthorData author = new AuthorData(prepareAuthor());

		Assert.assertNotNull(author.getId());
		Assert.assertEquals("tendersystems", author.getCompanyName());
		Assert.assertNotNull(author.getAnonymous());
		Assert.assertNotNull(author.getLoggedUser());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareAuthorData().equals(prepareAuthorData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareAuthorData().toString().equals(prepareAuthorData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareAuthorData().hashCode(), prepareAuthorData().hashCode());
	}

	private Author prepareAuthor() {
		Author author = new Author();

		author.setId(1l);
		author.setCompanyName("tendersystems");
		author.setAnonymous(new Person());

		author.setLoggedUser(new UserOutsourcer());
		author.getLoggedUser().setPerson(new Person());
		author.getLoggedUser().setOutsourcer(new Outsourcer());
		author.getLoggedUser().setChangePassword(new ChangePassword());

		return author;
	}

	private AuthorData prepareAuthorData() {
		return new AuthorData(prepareAuthor());
	}
}
