package cz.tendersystems.helpdesk.data.request;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.request.*;

public class CommentDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		CommentData comment = new CommentData(prepareComment());

		Assert.assertNotNull(comment.getId());
		Assert.assertEquals("Test komentáře", comment.getText());
		Assert.assertNotNull(comment.getCreatedDateTime());
		Assert.assertEquals(RequestStatus.NEW, comment.getRequestStatus());
		Assert.assertEquals("Zbyněk Richter", comment.getAuthor());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareCommentData().equals(prepareCommentData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareCommentData().toString().equals(prepareCommentData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareCommentData().hashCode(), prepareCommentData().hashCode());
	}

	private Comment prepareComment() {
		Comment comment = new Comment();

		comment.setId(1l);
		comment.setText("Test komentáře");
		comment.setCreatedDateTime(new Date());
		comment.setAuthor("Zbyněk Richter");

		return comment;
	}

	private CommentData prepareCommentData() {
		return new CommentData(prepareComment());
	}
}
