package cz.tendersystems.helpdesk.data.request;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.entity.request.*;

public class FileDataTest {

	@Test
	public void shouldCorrectConstuctor() {
		FileData file = new FileData(prepareFile());

		Assert.assertNotNull(file.getId());
		Assert.assertEquals("test_pdf", file.getName());
		Assert.assertNotNull(file.getSize());
		Assert.assertEquals("application/pdf", file.getContentType());
		Assert.assertNotNull(file.getCreatedDateTime());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareFileData().equals(prepareFileData()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareFileData().toString().equals(prepareFileData().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareFileData().hashCode(), prepareFileData().hashCode());
	}

	private File prepareFile() {
		File file = new File();

		file.setId(1l);
		file.setName("test_pdf");
		file.setSize(10l);
		file.setContentType("application/pdf");
		file.setCreatedDateTime(new Date());

		return file;
	}

	private FileData prepareFileData() {
		return new FileData(prepareFile());
	}
}
