package cz.tendersystems.helpdesk.entity.general;

import org.junit.*;
import cz.tendersystems.helpdesk.data.general.*;
import cz.tendersystems.helpdesk.entity.enums.*;

public class ApplicationLogTest {

	@Test
	public void shouldReturnCorrectObject() {
		ApplicationLog applicationLog1 = prepareApplicationLog();

		Assert.assertNotNull(applicationLog1.getIdRequest());
		Assert.assertEquals(LevelRecord.INFORMATION, applicationLog1.getLevel());
		Assert.assertEquals("Test aplikačního logu", applicationLog1.getOperation());
		Assert.assertNotNull(applicationLog1.getLoginName());
		Assert.assertNotNull(applicationLog1.getCreateDateTime());
		Assert.assertEquals("Test na aplikační log 1", applicationLog1.getDetails());

		ApplicationLog applicationLog2 = new ApplicationLog(prepareApplicationLogData());

		Assert.assertNotNull(applicationLog2.getIdRequest());
		Assert.assertEquals(LevelRecord.INFORMATION, applicationLog2.getLevel());
		Assert.assertEquals("Test aplikačního logu", applicationLog2.getOperation());
		Assert.assertNotNull(applicationLog2.getLoginName());
		Assert.assertNotNull(applicationLog2.getCreateDateTime());
		Assert.assertEquals("Test na aplikační log 2", applicationLog2.getDetails());
	}

	@Test
	public void shouldConvertObject() {
		ApplicationLog applicationLog = new ApplicationLog();

		ApplicationLog.convert(applicationLog, prepareApplicationLogData());

		Assert.assertNotNull(applicationLog.getIdRequest());
		Assert.assertEquals(LevelRecord.INFORMATION, applicationLog.getLevel());
		Assert.assertEquals("Test aplikačního logu", applicationLog.getOperation());
		Assert.assertNotNull(applicationLog.getLoginName());
		Assert.assertNotNull(applicationLog.getCreateDateTime());
		Assert.assertEquals("Test na aplikační log 2", applicationLog.getDetails());
	}

	private ApplicationLog prepareApplicationLog() {
		ApplicationLog applicationLog = new ApplicationLog();
		applicationLog.setIdRequest(Long.toString(1l));
		applicationLog.setLevel(LevelRecord.INFORMATION);
		applicationLog.setOperation("Test aplikačního logu");
		applicationLog.setLoginName("zbynek");
		applicationLog.setDetails("Test na aplikační log 1");

		return applicationLog;
	}

	private ApplicationLogData prepareApplicationLogData() {
		ApplicationLogData applicationLog = new ApplicationLogData();
		applicationLog.setIdRequest(Long.toString(1l));
		applicationLog.setLevel(LevelRecord.INFORMATION);
		applicationLog.setOperation("Test aplikačního logu");
		applicationLog.setLoginName("tomáš");
		applicationLog.setDetails("Test na aplikační log 2");

		return applicationLog;
	}
}
