package cz.tendersystems.helpdesk.entity.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;

public class OutsourcerTest {

	@Test
	public void shouldCorrectConstuctor() {
		Outsourcer outsourcer = prepareOutsourcer();

		Assert.assertEquals("tendersystems", outsourcer.getCompanyName());
		Assert.assertTrue(outsourcer.getActive());
		Assert.assertNotNull(outsourcer.getCreatedDateTime());
	}

	@Test
	public void shouldConvertObject() {
		Outsourcer outsourcer = new Outsourcer();

		Outsourcer.convert(outsourcer, prepareOutsourcerData());

		Assert.assertEquals("ample", outsourcer.getCompanyName());
		Assert.assertFalse(outsourcer.getActive());
		Assert.assertNotNull(outsourcer.getCreatedDateTime());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareOutsourcer().equals(prepareOutsourcer()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareOutsourcer().toString().equals(prepareOutsourcer().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareOutsourcer().hashCode(), prepareOutsourcer().hashCode());
	}

	private Outsourcer prepareOutsourcer() {
		Outsourcer outsourcer = new Outsourcer();

		outsourcer.setId(1l);
		outsourcer.setCompanyName("tendersystems");
		outsourcer.setActive(true);
		outsourcer.setCreatedDateTime(new Date());

		return outsourcer;
	}

	private OutsourcerData prepareOutsourcerData() {
		OutsourcerData outsourcer = new OutsourcerData();

		outsourcer.setId(1l);
		outsourcer.setCompanyName("ample");
		outsourcer.setActive(false);
		outsourcer.setCreatedDateTime(new Date());

		return outsourcer;
	}

}
