package cz.tendersystems.helpdesk.entity.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class UserSOutsourcerTest {

	@Test
	public void shouldCorrectConstuctor() {
		UserOutsourcer user = prepareUserOutsourcer();

		Assert.assertEquals("zbynek", user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.WATCHER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertEquals(UserAccountStatus.ENABLED, user.getUserAccountStatus());
		;
		Assert.assertNotNull(user.getOutsourcer());
	}

	@Test
	public void shouldConvertObject() {
		UserOutsourcer user = new UserOutsourcer();

		UserOutsourcer.convert(user, prepareUserOutsourcerData());

		Assert.assertNull(user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.SOLVER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertEquals(UserAccountStatus.FORBIDDEN, user.getUserAccountStatus());
		Assert.assertNotNull(user.getOutsourcer());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareUserOutsourcer().equals(prepareUserOutsourcer()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareUserOutsourcer().toString().equals(prepareUserOutsourcer().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareUserOutsourcer().hashCode(), prepareUserOutsourcer().hashCode());
	}

	private UserOutsourcer prepareUserOutsourcer() {
		UserOutsourcer user = new UserOutsourcer();
		user.setLoginName("zbynek");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.WATCHER);
		user.setUserAccountStatus(UserAccountStatus.ENABLED);
		user.setPerson(new Person());
		user.setOutsourcer(new Outsourcer());

		return user;
	}

	private UserOutsourcerData prepareUserOutsourcerData() {
		UserOutsourcerData user = new UserOutsourcerData();
		user.setLoginName("tomas");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.SOLVER);
		user.setUserAccountStatus(UserAccountStatus.FORBIDDEN);
		user.setPerson(new PersonData());
		user.setOutsourcer(new OutsourcerData());

		return user;
	}

}
