package cz.tendersystems.helpdesk.entity.organizationstructure;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class UserSolverTest {

	@Test
	public void shouldCorrectConstuctor() {
		UserSolver user = prepareUserSolver();

		Assert.assertEquals("zbynek", user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.WATCHER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertFalse(user.getProducts().isEmpty());
	}

	@Test
	public void shouldConvertObject() {
		UserSolver user = new UserSolver();

		UserSolver.convert(user, prepareUserSolverData());

		Assert.assertNull(user.getLoginName());
		Assert.assertNotNull(user.getCreatedDateTime());
		Assert.assertEquals(RoleType.SOLVER, user.getRoleType());
		Assert.assertNotNull(user.getPerson());
		Assert.assertNull(user.getProducts());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareUserSolver().equals(prepareUserSolver()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareUserSolver().toString().equals(prepareUserSolver().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareUserSolver().hashCode(), prepareUserSolver().hashCode());
	}

	private UserSolver prepareUserSolver() {
		UserSolver user = new UserSolver();
		user.setLoginName("zbynek");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.WATCHER);
		user.setPerson(new Person());
		user.setProducts(Arrays.asList(new Product()));

		return user;
	}

	private UserSolverData prepareUserSolverData() {
		UserSolverData user = new UserSolverData();
		user.setLoginName("tomas");
		user.setCreatedDateTime(new Date());
		user.setRoleType(RoleType.SOLVER);
		user.setPerson(new PersonData());
		user.setProducts(Arrays.asList(new ProductData()));

		return user;
	}

}
