package cz.tendersystems.helpdesk.entity.organizationstructure.embeddable;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class ChangePasswordTest {

	@Test
	public void shouldCorrectConstuctor() {
		ChangePassword changePassword1 = new ChangePassword(prepareChangePasswordData());

		Assert.assertEquals("894orf9hdwhewashaod5j8vz4ieafuooi1d7ip5pabq4a2sbim", changePassword1.getKey());
		Assert.assertNotNull(changePassword1.getExpirationDate());

		ChangePassword changePassword2 = new ChangePassword("test", new Date());

		Assert.assertEquals("test", changePassword2.getKey());
		Assert.assertNotNull(changePassword2.getExpirationDate());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareChangePassword().equals(prepareChangePassword()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareChangePassword().toString().equals(prepareChangePassword().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareChangePassword().hashCode(), prepareChangePassword().hashCode());
	}

	private ChangePassword prepareChangePassword() {
		ChangePassword changePassword = new ChangePassword();
		changePassword.setKey("894orf9hdwhewashaod5j8vz4ieafuooi1d7ip5pabq4a2sbim");
		changePassword.setExpirationDate(new Date());

		return changePassword;
	}

	private ChangePasswordData prepareChangePasswordData() {
		ChangePasswordData changePassword = new ChangePasswordData();
		changePassword.setKey("894orf9hdwhewashaod5j8vz4ieafuooi1d7ip5pabq4a2sbim");
		changePassword.setExpirationDate(new Date());

		return changePassword;
	}

}
