package cz.tendersystems.helpdesk.entity.organizationstructure.embeddable;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class PersonTest {

	@Test
	public void shouldCorrectConstuctor() {
		Person person = new Person(preparePersonData());

		Assert.assertEquals("Jiří", person.getName());
		Assert.assertEquals("Richter", person.getSurname());
		Assert.assertEquals("zbytos@gmail.com", person.getMail());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(preparePerson().equals(preparePerson()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(preparePerson().toString().equals(preparePerson().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(preparePerson().hashCode(), preparePerson().hashCode());
	}

	private Person preparePerson() {
		Person person = new Person();

		person.setName("Zbyněk");
		person.setSurname("Richter");
		person.setMail("zbytos@gmail.com");
		person.setTelephone("+420604931807");

		return person;
	}

	private PersonData preparePersonData() {
		PersonData person = new PersonData();

		person.setName("Jiří");
		person.setSurname("Richter");
		person.setMail("zbytos@gmail.com");

		return person;
	}
}
