package cz.tendersystems.helpdesk.entity.organizationstructure.sla;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class AssignmentTest {

	@Test
	public void shouldCorrectConstuctor() {
		Assignment assignment = prepareAssignment();

		Assert.assertNotNull(assignment.getId());
		Assert.assertNotNull(assignment.getSlaSchema());
		Assert.assertNotNull(assignment.getOutsourcer());
		Assert.assertNotNull(assignment.getProduct());
	}

	@Test
	public void shouldConvertObject() {
		Assignment assignment = new Assignment(prepareAssignmentData());

		Assert.assertNull(assignment.getId());
		Assert.assertNotNull(assignment.getSlaSchema());
		Assert.assertNull(assignment.getOutsourcer());
		Assert.assertNotNull(assignment.getProduct());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareAssignment().equals(prepareAssignment()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareAssignment().toString().equals(prepareAssignment().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareAssignment().hashCode(), prepareAssignment().hashCode());
	}

	private Assignment prepareAssignment() {
		Assignment assignment = new Assignment();

		assignment.setId(1l);
		assignment.setSlaSchema(new SlaSchema());
		assignment.setOutsourcer(new Outsourcer());
		assignment.setProduct(new Product());

		return assignment;
	}

	private AssignmentData prepareAssignmentData() {
		AssignmentData assignment = new AssignmentData();

		assignment.setId(1l);
		assignment.setSlaSchema(new SlaSchemaData());
		assignment.setProduct(new ProductData());

		return assignment;
	}
}
