package cz.tendersystems.helpdesk.entity.organizationstructure.sla;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class ProductTest {

	@Test
	public void shouldCorrectConstuctor() {
		Product product = prepareProduct();

		Assert.assertNotNull(product.getId());
		Assert.assertEquals("tenderarena", product.getName());
		Assert.assertTrue(product.getActive());
	}

	@Test
	public void shouldConvertObject() {
		Product product = new Product();

		Product.convert(product, prepareProductData());

		Assert.assertNull(product.getId());
		Assert.assertEquals("ample", product.getName());
		Assert.assertFalse(product.getActive());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareProduct().equals(prepareProduct()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareProduct().toString().equals(prepareProduct().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareProduct().hashCode(), prepareProduct().hashCode());
	}

	private Product prepareProduct() {
		Product product = new Product();
		product.setId(1l);
		product.setName("tenderarena");
		product.setActive(true);

		return product;
	}

	private ProductData prepareProductData() {
		ProductData product = new ProductData();
		product.setId(1l);
		product.setName("ample");
		product.setActive(false);

		return product;
	}
}
