package cz.tendersystems.helpdesk.entity.organizationstructure.sla;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class SlaSchemaTest {

	@Test
	public void shouldCorrectConstuctor() {
		SlaSchema slaSchema = prepareSlaSchema();

		Assert.assertNotNull(slaSchema.getId());
		Assert.assertEquals("Technický problém", slaSchema.getName());
		Assert.assertNotNull(slaSchema.getReactionTime());
		Assert.assertNotNull(slaSchema.getTimeToSolve());
		Assert.assertTrue(slaSchema.getActive());
	}

	@Test
	public void shouldConvertObject() {
		SlaSchema slaSchema = new SlaSchema();

		SlaSchema.convert(slaSchema, prepareSlaSchemaData());

		Assert.assertNull(slaSchema.getId());
		Assert.assertEquals("Problém", slaSchema.getName());
		Assert.assertNotNull(slaSchema.getReactionTime());
		Assert.assertNotNull(slaSchema.getTimeToSolve());
		Assert.assertFalse(slaSchema.getActive());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareSlaSchema().equals(prepareSlaSchema()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareSlaSchema().toString().equals(prepareSlaSchema().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareSlaSchema().hashCode(), prepareSlaSchema().hashCode());
	}

	private SlaSchema prepareSlaSchema() {
		SlaSchema slaSchema = new SlaSchema();

		slaSchema.setId(1l);
		slaSchema.setName("Technický problém");
		slaSchema.setReactionTime(new Date());
		slaSchema.setTimeToSolve(new Date());
		slaSchema.setActive(true);

		return slaSchema;
	}

	private SlaSchemaData prepareSlaSchemaData() {
		SlaSchemaData slaSchema = new SlaSchemaData();

		slaSchema.setId(2l);
		slaSchema.setName("Problém");
		slaSchema.setReactionTime(new Date());
		slaSchema.setTimeToSolve(new Date());
		slaSchema.setActive(false);

		return slaSchema;
	}
}
