package cz.tendersystems.helpdesk.entity.organizationstructure.sla;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.sla.*;

public class TimeActivityTest {

	@Test
	public void shouldCorrectConstuctor() {
		TimeActivity timeActivity = prepareTimeActivity();

		Assert.assertNotNull(timeActivity.getId());
		Assert.assertEquals(DayName.FRIDAY, timeActivity.getDayName());
		Assert.assertNotNull(timeActivity.getStartTime());
		Assert.assertNotNull(timeActivity.getEndTime());
	}

	@Test
	public void shouldConvertObject() {
		TimeActivity timeActivity = new TimeActivity();

		TimeActivity.convert(timeActivity, prepareTimeActivityData());

		Assert.assertNull(timeActivity.getId());
		Assert.assertEquals(DayName.MONDAY, timeActivity.getDayName());
		Assert.assertNotNull(timeActivity.getStartTime());
		Assert.assertNotNull(timeActivity.getEndTime());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareTimeActivity().equals(prepareTimeActivity()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareTimeActivity().toString().equals(prepareTimeActivity().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareTimeActivity().hashCode(), prepareTimeActivity().hashCode());
	}

	private TimeActivity prepareTimeActivity() {
		TimeActivity timeActivity = new TimeActivity();

		timeActivity.setId(1l);
		timeActivity.setDayName(DayName.FRIDAY);
		timeActivity.setStartTime(new Date());
		timeActivity.setEndTime(new Date());

		return timeActivity;
	}

	private TimeActivityData prepareTimeActivityData() {
		TimeActivityData timeActivity = new TimeActivityData();

		timeActivity.setId(2l);
		timeActivity.setDayName(DayName.MONDAY);
		timeActivity.setStartTime(new Date());
		timeActivity.setEndTime(new Date());

		return timeActivity;
	}
}
