package cz.tendersystems.helpdesk.entity.request;

import org.junit.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.embeddable.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.*;
import cz.tendersystems.helpdesk.entity.organizationalstructure.embeddable.*;

public class AuthorTest {

	@Test
	public void shouldCorrectConstuctor() {
		Author author = prepareAuthor();

		Assert.assertNotNull(author.getId());
		Assert.assertEquals("tendersystems", author.getCompanyName());
		Assert.assertNotNull(author.getAnonymous());
		Assert.assertNotNull(author.getLoggedUser());
	}

	@Test
	public void shouldConvertObject() {
		Author author = new Author();

		Author.convert(author, prepareAuthorData());

		Assert.assertNull(author.getId());
		Assert.assertEquals("ample", author.getCompanyName());
		Assert.assertNotNull(author.getAnonymous());
		Assert.assertNull(author.getLoggedUser());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareAuthor().equals(prepareAuthor()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareAuthor().toString().equals(prepareAuthor().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareAuthor().hashCode(), prepareAuthor().hashCode());
	}

	private Author prepareAuthor() {
		Author author = new Author();

		author.setId(1l);
		author.setCompanyName("tendersystems");
		author.setAnonymous(new Person());

		author.setLoggedUser(new UserOutsourcer());
		author.getLoggedUser().setPerson(new Person());
		author.getLoggedUser().setOutsourcer(new Outsourcer());
		author.getLoggedUser().setChangePassword(new ChangePassword());

		return author;
	}

	private AuthorData prepareAuthorData() {
		AuthorData author = new AuthorData();

		author.setId(1l);
		author.setCompanyName("ample");
		author.setAnonymous(new PersonData());

		return author;
	}
}
