package cz.tendersystems.helpdesk.entity.request;

import java.util.*;
import org.junit.*;
import cz.tendersystems.helpdesk.data.request.*;

public class FileTest {

	@Test
	public void shouldCorrectConstuctor() {
		File file = prepareFile();

		Assert.assertNotNull(file.getId());
		Assert.assertEquals("test_pdf", file.getName());
		Assert.assertNotNull(file.getSize());
		Assert.assertEquals("application/pdf", file.getContentType());
		Assert.assertNotNull(file.getCreatedDateTime());
		Assert.assertNotNull(file.getComment());
	}

	@Test
	public void shouldConvertObject() {
		File file = new File();

		File.convert(file, prepareFileData());

		Assert.assertNull(file.getId());
		Assert.assertEquals("test_doc", file.getName());
		Assert.assertNotNull(file.getSize());
		Assert.assertEquals("application/doc", file.getContentType());
		Assert.assertNotNull(file.getCreatedDateTime());
		Assert.assertNull(file.getComment());
	}

	@Test
	public void shouldReturnSameEquals() {
		Assert.assertTrue(prepareFile().equals(prepareFile()));
	}

	@Test
	public void shouldReturnSameObject() {
		Assert.assertTrue(prepareFile().toString().equals(prepareFile().toString()));
	}

	@Test
	public void shouldReturnSameHashCode() {
		Assert.assertEquals(prepareFile().hashCode(), prepareFile().hashCode());
	}

	private File prepareFile() {
		File file = new File();

		file.setId(1l);
		file.setName("test_pdf");
		file.setSize(10l);
		file.setContentType("application/pdf");
		file.setCreatedDateTime(new Date());
		file.setComment(new Comment());

		return file;
	}

	private FileData prepareFileData() {
		FileData file = new FileData();

		file.setId(2l);
		file.setName("test_doc");
		file.setSize(20l);
		file.setContentType("application/doc");
		file.setCreatedDateTime(new Date());

		return file;
	}
}
