package cz.tendersystems.helpdesk.general;

import java.text.*;
import java.util.*;
import org.junit.*;

public class DateAndTimeFormatTest {

	@Test
	public void shouldGetFormat() {
		Assert.assertEquals("dd.MM.yyyy", DateAndTimeFormat.FORMAT_OF_DATE.getFormat());
	}

	@Test
	public void shouldGetFormatter() {
		Assert.assertEquals("Central European Time", DateAndTimeFormat.FORMAT_OF_DATE.getFormatter().getTimeZone().getDisplayName());
	}

	@Test
	public void shouldPovideDateAsText() {
		Assert.assertEquals("22.02.2016", DateAndTimeFormat.FORMAT_OF_DATE.provideDateAsText(prepareDate()));
	}

	private Date prepareDate() {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh.mm.ss");
		String dateInString = "2016-02-22 12.00.00";
		try {
			return sdf.parse(dateInString);
		} catch (ParseException e) {
			e.printStackTrace();
		}

		return null;
	}
}
