package cz.tendersystems.helpdesk.general;

import java.time.*;
import org.junit.*;

public class ToolsForHolidaysTest {

	@Test
	public void shouldReturnTrue() {
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 1, 1)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 5, 1)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 5, 8)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 7, 5)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 7, 6)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 9, 28)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 10, 28)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 11, 17)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 12, 24)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 12, 25)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 12, 26)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 3, 28)));
		Assert.assertTrue(ToolsForHolidays.isHolidayDay(prepareDate(2016, 3, 25)));
	}

	@Test
	public void shouldReturnFalse() {
		Assert.assertFalse(ToolsForHolidays.isHolidayDay(prepareDate(2016, 1, 5)));
		Assert.assertFalse(ToolsForHolidays.isHolidayDay(prepareDate(2016, 5, 20)));
		Assert.assertFalse(ToolsForHolidays.isHolidayDay(prepareDate(2016, 5, 18)));
		Assert.assertFalse(ToolsForHolidays.isHolidayDay(prepareDate(2016, 7, 25)));
	}

	private LocalDate prepareDate(int year, int month, int dayOfMonth) {
		return LocalDate.of(year, month, dayOfMonth);
	}
}
