package cz.tendersystems.helpdesk.service.configuration;

import javax.ejb.*;
import org.jboss.arquillian.container.test.api.*;
import org.jboss.arquillian.junit.*;
import org.jboss.shrinkwrap.api.*;
import org.jboss.shrinkwrap.api.spec.*;
import org.junit.*;
import org.junit.runner.*;
import cz.tendersystems.helpdesk.*;

@RunWith(Arquillian.class)
public class ConfigurationServiceTest extends AbstractEJBTest {

	@EJB
	ConfigurationService configurationService;

	@Deployment
	public static Archive<?> createDeployment() {
		JavaArchive jar = prepareArchive();
		jar.addClasses(ConfigurationService.class, VersionType.class);
		jar.addAsResource("cz/tendersystems/helpdesk/configuration.properties");
		jar.addAsResource("cz/tendersystems/helpdesk/version.properties");
		System.out.println(jar.toString(true));

		return jar;
	}

	@Test
	public void shouldLoadConfiguration() {
		configurationService.loadConfiguration();

		Assert.assertEquals("java:global/test/test-ejb/helpdesk", configurationService.getEjbJndi("helpdesk"));
		Assert.assertNotNull(configurationService.getVersionName());
		Assert.assertNotNull(configurationService.getApplicationDomain());
		Assert.assertNotNull(configurationService.getRevisionNumber());
		Assert.assertEquals("test", configurationService.getApplicationName());
		Assert.assertEquals("info@tendersystems.cz", configurationService.getInformationMail());
		Assert.assertEquals("www.tendersystems.cz", configurationService.getProviderPage());
		Assert.assertEquals("support@tendersystems.cz", configurationService.getProviderMail());
		Assert.assertEquals("+420 226 258 888", configurationService.getProviderTelephone());
		Assert.assertNotNull(configurationService.getBinaryFilesFolder());
	}
}
