package cz.tendersystems.helpdesk.service.general.mail;

import org.junit.*;

public class EmbedTemplateTest {

	@Test
	public void shouldReturnObject() {
		String templateName = "linkForChangePassowrd";
		String supplantStringValue = "contact";
		String parameter = "zbytos@gmail.com";

		EmbedTemplate template = new EmbedTemplate(templateName, supplantStringValue, parameter);

		Assert.assertEquals(templateName, template.getTemplateName());
		Assert.assertEquals(supplantStringValue, template.getSupplantStringValue());
		Assert.assertEquals(parameter, template.getParameters()[0]);
	}

	@Test
	public void shouldReturnGeneralSalutation() {
		EmbedTemplate template = EmbedTemplate.generalSalutationTemplate("ahoj");

		Assert.assertEquals("general_salutation", template.getTemplateName());
		Assert.assertEquals("@generalSalutation", template.getSupplantStringValue());
		Assert.assertEquals("ahoj", template.getParameters()[0]);
	}

	@Test
	public void shouldReturnContact() {
		EmbedTemplate template = EmbedTemplate.generalContactTemplate("ahoj");

		Assert.assertEquals("general_contact", template.getTemplateName());
		Assert.assertEquals("@contact", template.getSupplantStringValue());
		Assert.assertEquals("ahoj", template.getParameters()[0]);
	}
}
