package cz.tendersystems.helpdesk.service.general.mail;

import java.util.*;
import javax.ejb.*;
import org.jboss.arquillian.container.test.api.*;
import org.jboss.arquillian.junit.*;
import org.jboss.shrinkwrap.api.*;
import org.jboss.shrinkwrap.api.spec.*;
import org.junit.*;
import org.junit.runner.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.exception.*;
import cz.tendersystems.helpdesk.service.configuration.*;

@RunWith(Arquillian.class)
public class MailServiceTest extends AbstractEJBTest {

	@EJB
	MailService mailService;

	@Deployment
	public static Archive<?> createDeployment() {
		JavaArchive jar = prepareArchive();
		jar.addClasses(MailTemplateService.class, EmbedTemplate.class, ConfigurationService.class, VersionType.class, MailService.class);
		jar.addAsResource("cz/tendersystems/helpdesk/configuration.properties");
		jar.addAsResource("cz/tendersystems/helpdesk/version.properties");
		System.out.println(jar.toString(true));

		return jar;
	}

	@Test
	public void shouldSendMailWithMoreUsers() {
		mailService.sendMail("linkForChagePassword", Arrays.asList("zbytos@gmail.com", "kenos123@seznam.cz"), "test");

	}

	@Test
	public void shouldFailToSendMail() {
		try {
			mailService.sendMail("empty_template", "zbytos@gmail.com", "test");
		} catch (HelpdeskException e) {
			Assert.assertEquals("Sablona emailu s nazvem neexistujiciSablona neexistuje", e.getMessage());
		}
	}

	@Test
	public void shouldSendMailWithOneUser() {
		mailService.sendMail("linkForFirstConfigurationPassword", "zbytos@gmail.com", "test");
	}
}
