package cz.tendersystems.helpdesk.service.log;

import javax.ejb.*;
import org.jboss.arquillian.container.test.api.*;
import org.jboss.arquillian.junit.*;
import org.jboss.arquillian.persistence.*;
import org.jboss.shrinkwrap.api.*;
import org.jboss.shrinkwrap.api.spec.*;
import org.junit.*;
import org.junit.runner.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.general.*;

@RunWith(Arquillian.class)
public class ApplicationLogServiceTest extends AbstractEJBTest {

	@Deployment
	public static Archive<?> createDeployment() {
		JavaArchive jar = prepareArchive();

		System.out.println(jar.toString(true));

		return jar;
	}

	@EJB
	ApplicationLogService applicationLogService;

	@Test
	@Cleanup(phase = TestExecutionPhase.BEFORE)
	public void shouldCreateApplicationLogWithoutUser() {
		Long idApplicationLog = 1L;

		applicationLogService.createLog(getClass(), "Vytvoření logu", "Vytvoření aplikačního logu s ID {0}", idApplicationLog);

		checkApplicationLog("Vytvoření logu", "Vytvoření aplikačního logu s ID 1", null, null);
	}

	@Test
	@Cleanup(phase = TestExecutionPhase.BEFORE)
	public void shouldCreateApplicationLogWithUser() {
		Long idApplicationLog = 1L;

		login(LOGIN_NAME_ADMINISTRATOR);
		applicationLogService.createLog(getClass(), "Vytvoření logu", "Vytvoření aplikačního logu s ID {0}", idApplicationLog);

		checkApplicationLog("Vytvoření logu", "Vytvoření aplikačního logu s ID 1", LOGIN_NAME_ADMINISTRATOR, null);
	}

	@Test
	@Cleanup(phase = TestExecutionPhase.BEFORE)
	public void shouldCreateApplicationLogWithIdRequest() {
		ApplicationLogData applicationLogData = new ApplicationLogData("Vytvoření logu", "Vytvoření aplikačního logu s ID {0}", "1");
		applicationLogData.setIdRequest(Long.toString(1));

		applicationLogService.createLog(getClass(), applicationLogData);

		checkApplicationLog("Vytvoření logu", "Vytvoření aplikačního logu s ID 1", null, Long.toString(1));
	}
}
