package cz.tendersystems.helpdesk.service.request;

import javax.ejb.*;
import org.jboss.arquillian.container.test.api.*;
import org.jboss.arquillian.junit.*;
import org.jboss.arquillian.persistence.*;
import org.jboss.shrinkwrap.api.*;
import org.jboss.shrinkwrap.api.spec.*;
import org.junit.*;
import org.junit.runner.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.exception.*;

@RunWith(Arquillian.class)
public class IdServiceTest extends AbstractEJBTest {

	@EJB
	IdService idService;

	@Deployment
	public static Archive<?> createDeployment() {
		JavaArchive jar = prepareArchive();

		jar.addClasses(IdService.class);

		System.out.println(jar.toString(true));

		return jar;
	}

	@Test
	public void shouldFailToCreateIdWhenNameOfRequestIsNull() {
		try {
			idService.createId(new RequestData());
		} catch (HelpdeskException e) {
			Assert.assertEquals("Nazev pozadavku musi byt vyplnen", e.getMessage());
		}
	}

	@Test
	@UsingDataSet("datasets/idServiceTest/request.xml")
	public void shouldCreateId() throws ValidationException {
		RequestData request = new RequestData();
		request.setName("test");

		String id = idService.createId(request);

		Assert.assertNotNull(id);
	}
}
