package cz.tendersystems.helpdesk;

import org.jboss.logging.*;
import cz.tendersystems.helpdesk.exception.*;
import cz.tendersystems.helpdesk.general.tools.*;

public abstract class AbstractAction {

	protected static final Logger log = Logger.getLogger(AbstractAction.class);

	protected void writeFacesMessage(HelpdeskException exception, LogLevel logLevel) {
		writeFacesMessage(exception.getMessage(), logLevel, exception.getParameters());
	}

	protected void writeFacesMessage(ValidationException exception, LogLevel logLevel) {
		writeFacesMessage(exception.getMessage(), logLevel, exception.getParameters());
	}

	protected void writeFacesMessage(String key, LogLevel logLevel, Object... parameters) {
		ToolsForInterface.writeFacesMessage(key, logLevel, parameters);
	}

	protected String localize(String key, Object... parameters) {
		return ToolsForInterface.localize(key, parameters);
	}
}
