package cz.tendersystems.helpdesk.export;

import java.io.*;
import java.text.*;
import javax.faces.context.*;
import cz.tendersystems.helpdesk.service.list.*;

public abstract class AbstractExportListAction extends AbstractExportAction {

	public <D, F extends Filter<?>> void export(ReparationOfRecordExport<D> action, Response<D> response) {
		try {
			FacesContext context = FacesContext.getCurrentInstance();
			ExternalContext externalContext = context.getExternalContext();

			externalContext.setResponseContentType(prepareContentType());
			externalContext.setResponseHeader("Content-Disposition", MessageFormat.format("attachment;filename={0}", prepareFileName()));

			prepareDocument(action, response, externalContext.getResponseOutputStream());
			context.responseComplete();
		} catch (Exception e) {
			throw new Error(e);
		}
	}

	@Override
	protected String prepareFileName() {
		return MessageFormat.format("{0}.{1}", localize("export.vypisSeznamu"), prepareSuffix());
	}

	protected abstract <D, F extends Filter<?>> void prepareDocument(ReparationOfRecordExport<D> action, Response<D> response, OutputStream output) throws Exception;
}