package cz.tendersystems.helpdesk.export.record;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.general.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.general.*;

public class RecordApplicationLog<D extends ApplicationLogData> implements Serializable, ReparationOfRecordExport<D> {

	private static final long serialVersionUID = 5156447635521718778L;

	@Override
	public List<String> prepareHeader() {
		List<String> headers = new ArrayList<String>();

		headers.add("id");
		headers.add("applicationLog.createdDateTime");
		headers.add("applicationLog.level");
		headers.add("applicationLog.operation");
		headers.add("applicationLog.details");
		headers.add("applicationLog.user");
		headers.add("applicationLog.request");

		return headers;
	}

	@Override
	public List<Object> prepareRecord(ApplicationLogData record) {
		List<Object> data = new ArrayList<Object>();

		data.add(record.getId());
		data.add(Tools.provideDateWithTime(record.getCreatedDateTime()));
		data.add(Tools.getEnumAsText(record.getLevel()));
		data.add(record.getOperation());
		data.add(record.getDetails());
		data.add(record.getLoginName());
		data.add(record.getIdRequest());

		return data;
	}
}