package cz.tendersystems.helpdesk.export.record;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.general.*;

public class RecordOutsourcer<D extends OutsourcerData> implements Serializable, ReparationOfRecordExport<D> {

	private static final long serialVersionUID = 5156447635521718778L;

	@Override
	public List<String> prepareHeader() {
		List<String> headers = new ArrayList<String>();

		headers.add("id");
		headers.add("outsourcer.companyName");
		headers.add("outsourcer.createdDateTime");
		headers.add("active");

		return headers;
	}

	@Override
	public List<Object> prepareRecord(OutsourcerData record) {
		List<Object> data = new ArrayList<Object>();

		data.add(record.getId());
		data.add(record.getCompanyName());
		data.add(Tools.provideDateAsText(record.getCreatedDateTime(), DateAndTimeFormat.FORMAT_OF_DATE));
		data.add(record.getActive());

		return data;
	}
}