package cz.tendersystems.helpdesk.export.record;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.general.*;

public class RecordRequest<D extends RequestData> implements Serializable, ReparationOfRecordExport<D> {

	private static final long serialVersionUID = -4445927789096383198L;

	@Override
	public List<String> prepareHeader() {
		List<String> headers = new ArrayList<String>();

		headers.add("id");
		headers.add("request.name");
		headers.add("requeststatus");
		headers.add("slaSchema");
		headers.add("author");
		headers.add("request.solver");
		headers.add("request.createdDateTime");
		headers.add("request.reactionTime");
		headers.add("request.timeToSolve");
		headers.add("request.dateOfClose");

		return headers;
	}

	@Override
	public List<Object> prepareRecord(RequestData record) {
		List<Object> data = new ArrayList<Object>();

		data.add(record.getId());
		data.add(record.getName());
		data.add(Tools.getEnumAsText(record.getRequestStatus()));
		data.add(record.getSlaSchema().getName());
		data.add(record.getAuthor());
		data.add(record.getSolver() == null ? "" : record.getSolver().getLoginName());
		data.add(Tools.provideDateWithTime(record.getCreatedDateTime()));
		data.add(Tools.provideDateWithTime(record.getReactionTime()));
		data.add(Tools.provideDateWithTime(record.getTimeToSolve()));
		data.add(record.getDateOfClose() == null ? "" : Tools.provideDateWithTime(record.getDateOfClose()));

		return data;
	}
}