package cz.tendersystems.helpdesk.export.record;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.general.*;

public class RecordSlaSchema<D extends SlaSchemaData> implements Serializable, ReparationOfRecordExport<D> {

	private static final long serialVersionUID = -6954097277204846289L;

	@Override
	public List<String> prepareHeader() {
		List<String> headers = new ArrayList<String>();

		headers.add("id");
		headers.add("name");
		headers.add("slaSchema.reactionTime");
		headers.add("slaSchema.timeToSolve");
		headers.add("active");

		return headers;
	}

	@Override
	public List<Object> prepareRecord(SlaSchemaData record) {
		List<Object> data = new ArrayList<Object>();

		data.add(record.getId());
		data.add(record.getName());
		data.add(Tools.provideDateAsText(record.getReactionTime(), DateAndTimeFormat.FORMAT_OF_TIME));
		data.add(Tools.provideDateAsText(record.getTimeToSolve(), DateAndTimeFormat.FORMAT_OF_TIME));
		data.add(record.getActive());

		return data;
	}
}