package cz.tendersystems.helpdesk.export.record;

import java.io.*;
import java.util.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.export.*;

public class RecordUser<D extends SystemUserData> implements Serializable, ReparationOfRecordExport<D> {

	private static final long serialVersionUID = 5156447635521718778L;

	@Override
	public List<String> prepareHeader() {
		List<String> headers = new ArrayList<String>();

		headers.add("user.loginName");
		headers.add("person.name");
		headers.add("person.surname");
		headers.add("person.mail");

		return headers;
	}

	@Override
	public List<Object> prepareRecord(SystemUserData record) {
		List<Object> data = new ArrayList<Object>();

		data.add(record.getLoginName());
		data.add(record.getPerson().getName());
		data.add(record.getPerson().getSurname());
		data.add(record.getPerson().getMail());

		return data;
	}
}