package cz.tendersystems.helpdesk.general;

import java.io.*;
import java.util.*;
import javax.inject.*;
import javax.servlet.http.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.exception.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;

@Named
@ViewScoped
public class FileUploadAction extends AbstractAction implements Serializable {

	private static final long serialVersionUID = -839555907656862347L;

	@NotNull
	private Part file;

	List<FileData> files = new ArrayList<>();

	public void addFileData() {
		files.add(prepareFileData());

		file = null;
	}

	public void removeFileData(FileData file) {
		files.remove(file);
	}

	private FileData prepareFileData() {
		FileData fileData = new FileData();
		fileData.setName(file.getSubmittedFileName());
		fileData.setContentType(file.getContentType());
		fileData.setSize(file.getSize());

		try {
			fileData.setInputStream(file.getInputStream());
		} catch (IOException e) {
			throw new HelpdeskException(e.getMessage());
		}

		return fileData;
	}

	public Part getFile() {
		return file;
	}

	public void setFile(Part file) {
		this.file = file;
	}

	public List<FileData> getFiles() {
		return files;
	}
}
