package cz.tendersystems.helpdesk.general;

import java.util.*;
import javax.ejb.*;
import javax.enterprise.context.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.general.ToolsForLog.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.service.security.*;

@Named
@RequestScoped
public class GeneralData {

	@EJB
	BasicSecurityService basicSecurityService;

	@EJB
	OutsourcerService outsourcerService;

	@EJB
	SlaSchemaService slaSchemaService;

	@EJB
	ProductService productService;

	public LevelRecord[] getLevelsRecord() {
		return LevelRecord.values();
	}

	public RoleType[] getRoleType() {
		return RoleType.values();
	}

	public RoleType[] getRoleOfSolver() {
		return RoleType.roleOfSolver();
	}

	public UserAccountStatus[] getUserAccountStatus() {
		return UserAccountStatus.values();
	}

	public DayName[] getDayNames() {
		return DayName.values();
	}

	public RequestStatus[] getRequestStatus() {
		return RequestStatus.values();
	}

	public List<ProductData> getProducts() {
		return productService.loadProducts();
	}

	public List<SlaSchemaData> getSlaSchemas() {
		return slaSchemaService.loadSlaSchemas();
	}

	public List<SlaSchemaData> getSlaSchemas(Long idProduct, AuthorData author) {
		return slaSchemaService.loadSlaSchemaProduct(idProduct, author);
	}
}