package cz.tendersystems.helpdesk.general;

import java.io.*;
import javax.enterprise.context.*;
import javax.faces.context.*;
import javax.inject.*;
import javax.servlet.http.*;
import org.apache.log4j.lf5.util.*;
import cz.tendersystems.helpdesk.entity.enums.*;

@Named
@RequestScoped
public class HelpAction {

	private static final String contentTypeForDownLoad = "application/x-download";
	private static final String headerKey = "Content-Disposition";
	private static final String headerValue = "attachment; filename=\"%s\";";
	private static final String fileName = "uzivatelska_prirucka.pdf";
	private static final String folderName = "file-for-help";

	public void downLoadFile() throws FileNotFoundException {
		downloadFile(new FileInputStream(Tools.SERVER_DATA_FOLDER_PATH + Tools.FILE_PATH_SEPARATOR + folderName + Tools.FILE_PATH_SEPARATOR + fileName));
	}

	private void downloadFile(InputStream inputStream) {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		HttpServletResponse response = (HttpServletResponse) facesContext.getExternalContext().getResponse();

		try {
			response.setHeader(headerKey, String.format(headerValue, fileName));
			response.setContentType(contentTypeForDownLoad);
			StreamUtils.copy(inputStream, response.getOutputStream());
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			ToolsForLog.write(getClass(), LevelRecord.ERROR, "Nelze stáhnout soubor", e);
			response.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
		} finally {
			try {
				response.getOutputStream().close();
			} catch (Exception e) {
				ToolsForLog.write(getClass(), LevelRecord.ERROR, "Nelze uzavřít proud", e);
			}
			facesContext.responseComplete();
		}
	}
}
