package cz.tendersystems.helpdesk.general.converters;

import java.text.*;
import javax.enterprise.context.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.convert.*;
import javax.inject.*;

@Named
@RequestScoped
public class EnumConverter implements Converter {

	private static final String atributEnumType = "enumType";

	@Override
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public Object getAsObject(FacesContext context, UIComponent component, String stringValue) {
		if (stringValue != null) {
			String keyAtributeType = getKeyAtributeType(component);
			if (!stringValue.isEmpty() && component.getAttributes().containsKey(keyAtributeType) && component.getAttributes().get(keyAtributeType) != null && ((Class<?>) component.getAttributes().get(keyAtributeType)).isEnum())
				return Enum.valueOf(((Class<? extends Enum>) component.getAttributes().get(keyAtributeType)), stringValue);
			else if (stringValue.isEmpty())
				return stringValue;
		}
		throw new UnsupportedOperationException();
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object object) {
		if (object != null) {
			if (object.getClass().isEnum()) {
				String keyAtributeType = getKeyAtributeType(component);
				if (!component.getAttributes().containsKey(keyAtributeType))
					component.getAttributes().put(keyAtributeType, object.getClass());
				return ((Enum<?>) object).name();
			} else if (object instanceof String)
				return (String) object;
		}
		throw new IllegalArgumentException(MessageFormat.format("Objekt [{0}] neni enum", object));
	}

	private String getKeyAtributeType(UIComponent component) {
		return MessageFormat.format("{0}:{1}", component.getClientId(), atributEnumType);
	}
}