package cz.tendersystems.helpdesk.general.converters;

import java.text.*;
import javax.enterprise.context.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.convert.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.general.*;

@Named
@RequestScoped
public class FileSizeConverter implements Converter {

	@Inject
	NumberConverter numberConverter;

	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String stringValue) {
		try {
			return stringValue == null || stringValue.trim().isEmpty() ? null : Long.valueOf(stringValue);
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException(MessageFormat.format("String {0} can not be converted to a number", stringValue));
		}
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object object) {
		if (object instanceof Long) {
			return ToolsForFileSize.convertToString((Long) object);
		}

		throw new IllegalArgumentException(MessageFormat.format("Object {0} is not a number", object));
	}
}