package cz.tendersystems.helpdesk.general.converters;

import java.text.*;
import javax.enterprise.context.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.convert.*;
import javax.inject.*;

@Named
@RequestScoped
public class ObjectConverter implements Converter {

	private static final String converterId = "objectConverter";

	private Integer elementIndex = 0;

	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String attributeTypeKey) {
		if (attributeTypeKey != null && component.getAttributes().containsKey(attributeTypeKey) && component.getAttributes().get(attributeTypeKey) != null) {
			Object value = component.getAttributes().get(attributeTypeKey);

			return value instanceof String && ((String) value).isEmpty() ? null : value;
		} else if (attributeTypeKey != null && attributeTypeKey.isEmpty()) {
			return attributeTypeKey;
		}

		throw new UnsupportedOperationException();
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object object) {
		String attributeTypeKey = getAttributeTypeKey(component);

		if (object != null) {
			component.getAttributes().put(attributeTypeKey, object);

			return attributeTypeKey;
		}

		throw new IllegalArgumentException(MessageFormat.format("Object [{0}] is null", object));
	}

	private String getAttributeTypeKey(UIComponent component) {
		return MessageFormat.format("{0}:{1}:{2}", component.getClientId(), converterId, elementIndex++);
	}
}
