package cz.tendersystems.helpdesk.general.converters;

import javax.enterprise.context.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.request.*;

@Named
@RequestScoped
public class ReparationStringValueConverter extends AbstractAction {

	@Inject
	NumberConverter numberConverter;

	@Inject
	AuthorConverter authorConverter;

	public String prepareStringValue(Object object) {
		if (object == null) {
			return "";
		} else if (object instanceof String) {
			return (String) object;
		} else if (object instanceof Number) {
			return numberConverter.getAsString(null, null, object);
		} else if (object instanceof Boolean) {
			return localize(object.toString());
		} else if (object instanceof AuthorData) {
			return authorConverter.getAsString(null, null, object);
		}

		return "Nan";
	}
}
