package cz.tendersystems.helpdesk.general.jsf.exception;

import java.text.*;
import java.util.*;
import javax.faces.*;
import javax.faces.application.*;
import javax.faces.context.*;
import javax.faces.event.*;
import javax.servlet.http.*;

public class HelpdeskExceptionHandler extends ExceptionHandlerWrapper {

	private ExceptionHandler parent;

	public HelpdeskExceptionHandler(ExceptionHandler parent) {
		this.parent = parent;
	}

	@Override
	public void handle() throws FacesException {
		Iterator<ExceptionQueuedEvent> iterator = getUnhandledExceptionQueuedEvents().iterator();

		while (iterator.hasNext()) {
			try {
				Throwable cause = iterator.next().getContext().getException();
				ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();

				if (cause instanceof ViewExpiredException) {
					externalContext.redirect(pripravitStranku((HttpServletRequest) externalContext.getRequest()));
				} else {
					Map<String, Object> session = externalContext.getSessionMap();

					session.put("cause", cause);
					session.put("page", pripravitStranku((HttpServletRequest) externalContext.getRequest()));
					externalContext.redirect(MessageFormat.format("{0}/errors/detail.jsf", externalContext.getRequestContextPath()));
				}
			} catch (Throwable e) {
				e.printStackTrace();
			} finally {
				iterator.remove();
			}
		}

		parent.handle();
	}

	@Override
	public ExceptionHandler getWrapped() {
		return parent;
	}

	private String pripravitStranku(HttpServletRequest request) {
		StringBuilder buffer = new StringBuilder(request.getRequestURL());

		if (request.getQueryString() != null) {
			buffer.append("?").append(request.getQueryString());
		}

		return buffer.toString();
	}
}