package cz.tendersystems.helpdesk.general.jsf.extensions;

import javax.enterprise.context.spi.*;
import javax.enterprise.inject.spi.*;
import javax.faces.context.*;

public class ViewContext implements Context {

	@Override
	public Class<ViewScoped> getScope() {
		return ViewScoped.class;
	}

	@Override
	public <T> T get(Contextual<T> contextual, CreationalContext<T> creationalContext) {
		T t = get(contextual);

		if (t == null) {
			Bean<T> bean = (Bean<T>) contextual;
			FacesContext.getCurrentInstance().getViewRoot().getViewMap(true).put(bean.getName(), t = bean.create(creationalContext));
		}

		return t;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <T> T get(Contextual<T> contextual) {
		return (T) FacesContext.getCurrentInstance().getViewRoot().getViewMap(true).get(((Bean<T>) contextual).getName());
	}

	@Override
	public boolean isActive() {
		return true;
	}
}
