package cz.tendersystems.helpdesk.general.jsf.parametr;

import java.text.*;
import javax.enterprise.inject.*;
import javax.enterprise.inject.spi.*;
import javax.faces.context.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;

@Named
public class ParametrAction extends AbstractAction {

	@Produces
	@Parametr
	public Long prepareNumberParameter(InjectionPoint injection) throws ParseException {
		Object parameter = loadParameter(injection);
		return parameter == null || parameter.toString().isEmpty() ? null : Long.parseLong((String) parameter);
	}

	@Produces
	@Parametr
	public String prepareStringParameter(InjectionPoint injection) throws ParseException {
		return (String) loadParameter(injection);
	}

	@Produces
	@Parametr
	public Boolean prepareBooleanParameter(InjectionPoint injection) {
		Object parameter = loadParameter(injection);
		return parameter == null || parameter.toString().isEmpty() ? null : Boolean.parseBoolean((String) parameter);
	}

	private Object loadParameter(InjectionPoint injection) {
		return FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap().get(injection.getMember().getName());
	}
}