package cz.tendersystems.helpdesk.general.jsf.resources;

import java.io.*;
import javax.validation.constraints.*;

public class LayoutCustomization implements Serializable {

	private static final long serialVersionUID = -618687333018366479L;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String firstMainColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String firstAdditionColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String secondMainColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String secondAdditionColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String thirdMainColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String thirdAdditionColor;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String inputText;

	@Pattern(regexp = "^[a-fA-F0-9]{6}$")
	private String backgroundMessageColor;

	public LayoutCustomization() {
	}

	public String getFirstMainColor() {
		return firstMainColor;
	}

	public void setFirstMainColor(String firstMainColor) {
		this.firstMainColor = firstMainColor;
	}

	public String getFirstAdditionColor() {
		return firstAdditionColor;
	}

	public void setFirstAdditionColor(String firstAdditionColor) {
		this.firstAdditionColor = firstAdditionColor;
	}

	public String getSecondMainColor() {
		return secondMainColor;
	}

	public void setSecondMainColor(String secondMainColor) {
		this.secondMainColor = secondMainColor;
	}

	public String getSecondAdditionColor() {
		return secondAdditionColor;
	}

	public void setSecondAdditionColor(String secondAdditionColor) {
		this.secondAdditionColor = secondAdditionColor;
	}

	public String getThirdMainColor() {
		return thirdMainColor;
	}

	public void setThirdMainColor(String thirdMainColor) {
		this.thirdMainColor = thirdMainColor;
	}

	public String getThirdAdditionColor() {
		return thirdAdditionColor;
	}

	public void setThirdAdditionColor(String thirdAdditionColor) {
		this.thirdAdditionColor = thirdAdditionColor;
	}

	public String getInputText() {
		return inputText;
	}

	public void setInputText(String inputText) {
		this.inputText = inputText;
	}

	public String getBackgroundMessageColor() {
		return backgroundMessageColor;
	}

	public void setBackgroundMessageColor(String backgroundMessageColor) {
		this.backgroundMessageColor = backgroundMessageColor;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof LayoutCustomization) {
			LayoutCustomization layoutCustomization = (LayoutCustomization) obj;

			boolean match = layoutCustomization.getFirstMainColor().equalsIgnoreCase(getFirstMainColor());
			match &= layoutCustomization.getFirstAdditionColor().equalsIgnoreCase(getFirstAdditionColor());

			match &= layoutCustomization.getSecondMainColor().equalsIgnoreCase(getSecondMainColor());
			match &= layoutCustomization.getSecondAdditionColor().equalsIgnoreCase(getSecondAdditionColor());

			match &= layoutCustomization.getThirdMainColor().equalsIgnoreCase(getThirdMainColor());
			match &= layoutCustomization.getThirdAdditionColor().equalsIgnoreCase(getThirdAdditionColor());

			match &= layoutCustomization.getInputText().equalsIgnoreCase(getInputText());
			match &= layoutCustomization.getBackgroundMessageColor().equalsIgnoreCase(getBackgroundMessageColor());

			return match;
		}

		return false;
	}

	@Override
	public int hashCode() {
		int hash = getFirstMainColor().hashCode() + 37;
		hash *= getFirstAdditionColor().hashCode() + 37;

		hash *= getSecondMainColor().hashCode() + 37;
		hash *= getSecondAdditionColor().hashCode() + 37;

		hash *= getThirdMainColor().hashCode() + 37;
		hash *= getThirdAdditionColor().hashCode() + 37;

		hash *= getInputText().hashCode() + 37;
		hash *= getBackgroundMessageColor().hashCode() + 37;

		return hash;
	}
}