package cz.tendersystems.helpdesk.general.jsf.resources;

import javax.faces.application.*;

public class StyleResource extends AbstractResource {

	public StyleResource(String id, Resource wrapper) {
		super(id, wrapper);
	}

	@Override
	public String getContentType() {
		return "text/css";
	}

	@Override
	protected byte[] processData(LayoutCustomization layoutCustomization, byte[] data) {
		String modifiedStyle = new String(data);

		modifiedStyle = replace(modifiedStyle, "@firstMainColor", layoutCustomization.getFirstMainColor());
		modifiedStyle = replace(modifiedStyle, "@firstAdditionColor", layoutCustomization.getFirstAdditionColor());
		modifiedStyle = replace(modifiedStyle, "@secondMainColor", layoutCustomization.getSecondMainColor());
		modifiedStyle = replace(modifiedStyle, "@secondAdditionColor", layoutCustomization.getSecondAdditionColor());
		modifiedStyle = replace(modifiedStyle, "@thirdMainColor", layoutCustomization.getThirdMainColor());
		modifiedStyle = replace(modifiedStyle, "@thirdAdditionColor", layoutCustomization.getThirdAdditionColor());
		modifiedStyle = replace(modifiedStyle, "@inputColor", layoutCustomization.getInputText());
		modifiedStyle = replace(modifiedStyle, "@backgroundMessageColor", layoutCustomization.getBackgroundMessageColor());

		return modifiedStyle.getBytes();
	}

	private String replace(String stlye, String key, Object value) {
		return nahradit(stlye, key, value, "#");
	}

	private String nahradit(String style, String key, Object value, String prefix) {
		return style.replaceAll(key, prefix + (value != null ? (String) value : properties.getProperty(key)));
	}
}
