package cz.tendersystems.helpdesk.general.tools;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.enterprise.context.*;
import javax.faces.context.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.general.*;
import cz.tendersystems.helpdesk.general.jsf.messages.*;

@Named
@RequestScoped
public class ToolsForInterface implements Serializable {

	private static final long serialVersionUID = 5211929165583571617L;

	public ToolsForInterface() {
	}

	public static void writeFacesMessage(String key, LogLevel loglevel, Object... parameters) {
		if (key != null && loglevel.getViewLevel() != null) {
			FacesContext.getCurrentInstance().addMessage(null, new GeneralFacesMessage(loglevel.getViewLevel(), localize(key, parameters)));
		}
	}

	public static String localize(String key, Object... parameters) {
		ResourceBundle texts = FacesContext.getCurrentInstance().getApplication().getResourceBundle(FacesContext.getCurrentInstance(), "texts");

		return MessageFormat.format(key != null && texts.containsKey(key) ? texts.getString(key) : key, parameters);
	}

	public String prepareActualYear() {
		return String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
	}

	public boolean isEnum(Class<?> type) {
		return Tools.isEnum(type);
	}

	public boolean isNumber(Class<?> type) {
		return Tools.isNumber(type);
	}
}
