package cz.tendersystems.helpdesk.log;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.general.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.log.list.*;

@Named
@ViewScoped
public class ApplicationLogListAction extends AbstractListAction<ApplicationLogData, ApplicationLogFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	ApplicationLogListService applicationLogListService;

	@Override
	protected ApplicationLogFilter prepareFilter() {
		return new ApplicationLogFilter();
	}

	@Override
	protected Response<ApplicationLogData> find(RequestList<ApplicationLogFilter> request) {
		return applicationLogListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<ApplicationLogData> prepareRecordExport() {
		return new RecordApplicationLog<ApplicationLogData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 60f, 100f, 60f, 250f, 480f, 100f, 60f };
	}
}
