package cz.tendersystems.helpdesk.organizationalstructure;

import java.io.*;
import java.util.*;
import javax.annotation.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.general.jsf.parameter.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.*;

@Named
@ViewScoped
public class OutsourcerAction extends AbstractAction implements Serializable {

	private static final long serialVersionUID = -5322707156347481463L;

	@EJB
	OutsourcerService outsourcerService;

	@EJB
	UserService userService;

	@Inject
	@Parameter
	private Long id;

	private OutsourcerData outsourcer;

	@PostConstruct
	public void initialize() {
		if (id == null) {
			outsourcer = new OutsourcerData();

			return;
		}

		outsourcer = outsourcerService.loadOutsourcer(id);
	}

	public String createOutsourcer() {
		id = outsourcerService.createOutsourcer(outsourcer);

		writeFacesMessage("information.successfulOutsourcerCreation", LogLevel.INFORMATION);

		return "detailOutsourcer";
	}

	public String updateOutsourcer() {
		outsourcerService.updateOutsourcer(outsourcer);

		writeFacesMessage("information.successfulOutsourcerUpdate", LogLevel.INFORMATION);

		return "detailOutsourcer";
	}

	public void updateActivityOfOutsourcerAndUsers(boolean active) {
		outsourcerService.updateActivityOfOutsourcerAndUsers(id, active);
		writeFacesMessage("information.successfulActivityOfOutsourcerAndUsersUpdate", LogLevel.INFORMATION);
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public OutsourcerData getOutsourcer() {
		return outsourcer;
	}

	public void setOutsourcer(OutsourcerData outsourcer) {
		this.outsourcer = outsourcer;
	}

	public List<UserOutsourcerData> getUsers() {
		return userService.loadUserOfOutsourcer(id);
	}
}
