package cz.tendersystems.helpdesk.organizationalstructure;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.list.*;

@Named
@ViewScoped
public class OutsourcerListAction extends AbstractListAction<OutsourcerData, OutsourcerFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	OutsourcerListService outsourcerListService;

	@Override
	protected OutsourcerFilter prepareFilter() {
		return new OutsourcerFilter();
	}

	@Override
	protected Response<OutsourcerData> find(RequestList<OutsourcerFilter> request) {
		return outsourcerListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<OutsourcerData> prepareRecordExport() {
		return new RecordOutsourcer<OutsourcerData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 150f, 580f, 300f, 70f };
	}
}
