package cz.tendersystems.helpdesk.organizationalstructure;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.list.*;

@Named
@ViewScoped
public class UserListAction extends AbstractListAction<SystemUserData, UserFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	UserListService userListService;

	@Override
	protected UserFilter prepareFilter() {
		return new UserFilter();
	}

	@Override
	protected Response<SystemUserData> find(RequestList<UserFilter> request) {
		return userListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<SystemUserData> prepareRecordExport() {
		return new RecordUser<SystemUserData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 275f, 275f, 275f, 275f };
	}
}
