package cz.tendersystems.helpdesk.organizationalstructure.sla;

import java.io.*;
import java.util.*;
import javax.annotation.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.general.jsf.parameter.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.sla.*;

@Named
@ViewScoped
public class ProductAction extends AbstractAction implements Serializable {

	private static final long serialVersionUID = -6465653673159971774L;

	@EJB
	ProductService productService;

	@EJB
	UserService userService;

	@Inject
	@Parameter
	private Long id;

	private ProductData product;

	public Long getId() {
		return id;
	}

	@PostConstruct
	public void initialize() {
		if (id == null) {
			product = new ProductData();

			return;
		}

		product = productService.loadProduct(id);
	}

	public String createProduct() {
		id = productService.createProduct(product);

		writeFacesMessage("information.successfulProductCreation", LogLevel.INFORMATION);

		return "detailProduct";
	}

	public String updateProduct() {
		productService.updateProduct(product);

		writeFacesMessage("information.successfulProductUpdate", LogLevel.INFORMATION);

		return "detailProduct";
	}

	public void updateActivityOfProduct(boolean active) {
		productService.updateActivityOfProduct(id, active);

		writeFacesMessage("information.successfulActivityOfProductUpdate", LogLevel.INFORMATION);
	}

	public ProductData getProduct() {
		return product;
	}

	public void setProduct(ProductData product) {
		this.product = product;
	}

	public List<UserSolverData> getUsers() {
		return userService.loadUserOfProduct(id);
	}
}
