package cz.tendersystems.helpdesk.organizationalstructure.sla;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.sla.list.*;

@Named
@ViewScoped
public class ProductListAction extends AbstractListAction<ProductData, ProductFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	ProductListService productListService;

	@Override
	protected ProductFilter prepareFilter() {
		return new ProductFilter();
	}

	@Override
	protected Response<ProductData> find(RequestList<ProductFilter> request) {
		return productListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<ProductData> prepareRecordExport() {
		return new RecordProduct<ProductData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 200f, 800f, 100f };
	}
}
