package cz.tendersystems.helpdesk.organizationalstructure.sla;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.organizationalstructure.sla.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.organizationalstructure.sla.list.*;

@Named
@ViewScoped
public class SlaSchemaListAction extends AbstractListAction<SlaSchemaData, SlaSchemaFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	SlaSchemaListService slaSchemaListService;

	@Override
	protected SlaSchemaFilter prepareFilter() {
		return new SlaSchemaFilter();
	}

	@Override
	protected Response<SlaSchemaData> find(RequestList<SlaSchemaFilter> request) {
		return slaSchemaListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<SlaSchemaData> prepareRecordExport() {
		return new RecordSlaSchema<SlaSchemaData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 220f, 220f, 220f, 220f, 220f };
	}
}
