package cz.tendersystems.helpdesk.request;

import java.io.*;
import javax.ejb.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.data.request.*;
import cz.tendersystems.helpdesk.export.*;
import cz.tendersystems.helpdesk.export.record.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;
import cz.tendersystems.helpdesk.service.list.*;
import cz.tendersystems.helpdesk.service.request.list.*;

@Named
@ViewScoped
public class RequestListAction extends AbstractListAction<RequestData, RequestFilter> implements Serializable {

	private static final long serialVersionUID = -6265697942033085432L;

	@EJB
	RequestListService requestListService;

	@Override
	protected RequestFilter prepareFilter() {
		return new RequestFilter();
	}

	@Override
	protected Response<RequestData> find(RequestList<RequestFilter> request) {
		return requestListService.find(request);
	}

	@Override
	protected ReparationOfRecordExport<RequestData> prepareRecordExport() {
		return new RecordRequest<RequestData>();
	}

	@Override
	protected float[] prepareColumnsWidthExport() {
		return new float[] { 110f, 110f, 110f, 110f, 110f, 110f, 110f, 110f, 110f, 110f };
	}
}
