package cz.tendersystems.helpdesk.security;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.annotation.*;
import javax.faces.application.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.event.*;
import javax.inject.*;
import javax.validation.constraints.*;
import cz.tendersystems.helpdesk.*;
import cz.tendersystems.helpdesk.general.*;
import cz.tendersystems.helpdesk.general.jsf.extensions.*;

@Named
@ViewScoped
public class CaptchaAction extends AbstractAction implements Serializable {

	private static final long serialVersionUID = -6598323836951617408L;

	private static final Integer maxNumberGenerate = 20;

	private Integer expectedValue;

	@NotNull
	private Integer enteredValue;

	private String captcha;

	@PostConstruct
	public void initialize() throws IOException {

		Random generator = new Random();

		int a = generator.nextInt(maxNumberGenerate) + 1;
		int b = generator.nextInt(maxNumberGenerate) + 1;

		expectedValue = a + b;
		captcha = (MessageFormat.format("{0} + {1} = ", a, b));
	}

	public void validate(ComponentSystemEvent event) {
		FacesContext context = FacesContext.getCurrentInstance();
		UIComponent component = event.getComponent();

		UIInput enteredValueArray = (UIInput) component.findComponent("checkCaptcha");

		String enteredValue = enteredValueArray.getLocalValue() == null ? "" : enteredValueArray.getLocalValue().toString();

		if (!enteredValue.equals("") && Integer.parseInt(enteredValue) != expectedValue) {
			context.addMessage(enteredValueArray.getClientId(), new FacesMessage(FacesMessage.SEVERITY_ERROR, "", Tools.getText("error.valueIsBad")));
			context.renderResponse();
		}
	}

	public Integer getEnteredValue() {
		return enteredValue;
	}

	public void setEnteredValue(Integer enteredValue) {
		this.enteredValue = enteredValue;
	}

	public String getCaptcha() {
		return captcha;
	}
}
