package cz.tendersystems.helpdesk.security;

import java.security.*;
import javax.ejb.*;
import javax.enterprise.context.*;
import javax.faces.context.*;
import javax.inject.*;
import cz.tendersystems.helpdesk.entity.enums.*;
import cz.tendersystems.helpdesk.service.security.*;

@Named
@RequestScoped
public class SecurityAction {

	@EJB
	BasicSecurityService basicSecurityService;

	public Principal getIdentity() {
		return FacesContext.getCurrentInstance().getExternalContext().getUserPrincipal();
	}

	public boolean isUserLogged() {
		return basicSecurityService.isUserLogged();
	}

	public boolean isUserAdministrator() {
		return basicSecurityService.isUserAdministrator();
	}

	public boolean isRoleType(RoleType roleType) {
		return basicSecurityService.isRoleType(roleType);
	}
}