package cz.tendersystems.helpdesk.exception;

import java.text.*;
import java.util.*;

public class ValidationException extends Exception {

	private static final long serialVersionUID = -7244351511664222661L;

	private Object[] parameters;
	private String report;
	private List<String> reports;

	public ValidationException(String report, Object... parameters) {
		super(MessageFormat.format(report, parameters));

		this.report = report;
		this.parameters = parameters;
	}

	public ValidationException(String report, Throwable pricina, Object... parameters) {
		super(MessageFormat.format(report, pricina, parameters));

		this.report = report;
		this.parameters = parameters;
	}

	public ValidationException(List<String> reports) {
		super(MessageFormat.format("{0}", reports));
		this.reports = reports;
	}

	public Object[] getParameters() {
		return parameters;
	}

	public String getReport() {
		return report;
	}

	public void setReport(String report) {
		this.report = report;
	}

	public List<String> getReports() {
		return reports;
	}

	public void setReports(List<String> reports) {
		this.reports = reports;
	}
}
